﻿
using Microsoft.Moles.Framework;
using Microsoft.VisualStudio.TestTools;
using System;
using System.Collections.Generic;
using System.Web.Mvc;
using Moq;
using Xunit;
using Weapsy.Entities;
using Weapsy.Services;
using Weapsy.Apps.Forum.Controllers;
using Weapsy.Apps.Forum.Models.AdminModels;
using Weapsy.Apps.Forum.Services;
using Weapsy.Apps.Forum.Extensions.Moles;
using Weapsy.Apps.Forum.Tests.TestAttributes;
using Weapsy.Apps.Forum.Tests.Stubs;

namespace Weapsy.Apps.Forum.Tests.Controllers
{
    public class AdminControllerTest
    {

        #region Private Members

        private Mock<ICategoryService> mockCategoryService;
        private Mock<IConfigurationService> mockConfigurationService;
        private Mock<IPermissionSetService> mockPermissionSetService;
        private Mock<ISectionService> mockSectionService;
        private Mock<ISettingSetService> mockSettingSetService;
        private Mock<Apps.Forum.Services.IInstallService> mockInstallService;
        private Mock<IRoleService> mockRoleService;

        #endregion

        #region Constructors

        public AdminControllerTest()
        {
            mockCategoryService = new Mock<ICategoryService>();
            mockConfigurationService = new Mock<IConfigurationService>();
            mockPermissionSetService = new Mock<IPermissionSetService>();
            mockSectionService = new Mock<ISectionService>();
            mockSettingSetService = new Mock<ISettingSetService>();
            mockInstallService = new Mock<Apps.Forum.Services.IInstallService>();
            mockRoleService = new Mock<IRoleService>();
        }

        #endregion

        #region Categories

        [Fact]
        [Microsoft.VisualStudio.TestTools.UnitTesting.HostType("Moles")]
        public void Categories_ReturnsViewWhereModelIsCategoryModelList()
        {
            AdminController target = new AdminController(
                mockCategoryService.Object, 
                mockConfigurationService.Object,
                mockPermissionSetService.Object, 
                mockSectionService.Object, 
                mockSettingSetService.Object, 
                mockInstallService.Object,
                mockRoleService.Object
            );

            int ConfigurationId = 1;

            mockCategoryService.Setup(x => x.GetList(ConfigurationId)).Returns(CategoryStubs.GetCategoryListStub());

            MMappingExtensions.ToModelsListOfForumCategory = (lst) => { return CategoryStubs.GetCategoryModelListStub(); };

            var result = target.Categories() as ViewResult;

            Assert.IsType(typeof(List<ForumCategoryModel>), result.ViewData.Model);
        }

        #endregion

        //[Fact]
        //public void Create_ReturnsViewWhereModelIsAppModelList()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);

        //    var result = target.Create() as ViewResult;

        //    Assert.IsType(typeof(List<AppModel>), result.ViewData.Model);
        //}

        //[Fact]
        //public void Create_GivenAppModelFromPOST_ReturnsViewWhereModelIsAppModelList()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);

        //    mockAppService.Setup(x => x.GetByName(It.IsAny<string>(), false)).Returns((App)null);

        //    var result = target.Create(new AppModel()) as ViewResult;

        //    Assert.IsType(typeof(List<AppModel>), result.ViewData.Model);
        //}

        //[Fact]
        //public void Delete_GivenAppModel_DeletesAppAndRedirectsToListAction()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
        //    mockAppService.Setup(x => x.GetById(It.IsAny<int>(), false)).Returns(new App());

        //    var result = target.Delete(new AppModel()) as RedirectToRouteResult;

        //    mockAppService.Verify(x => x.Delete(It.IsAny<App>()), Times.Once());
        //    Assert.Equal("List", result.RouteValues["action"]);
        //}

        //[Fact]
        //[Moled]
        //public void Edit_GivenId_ReturnsViewWhereModelIsAppModel()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
        //    mockAppService.Setup(x => x.GetById(It.IsAny<int>())).Returns(new App());
        //    MMappingExtensions.ToModelApp = (ent) => { return new AppModel(); };
        //    int Id = 1;

        //    var result = target.Edit(Id) as ViewResult;

        //    Assert.IsType(typeof(AppModel), result.ViewData.Model);
        //}
        
        //[Fact]
        //public void Index_RedirectsToListAction()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
            
        //    var result = target.Index() as RedirectToRouteResult;
            
        //    Assert.Equal("List", result.RouteValues["action"]);
        //}



        //[Fact]
        //[Moled]
        //public void Update_GivenAppModelFromPOST_RedirectsToEditAction()
        //{
        //    AdminController target = new AdminController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
        //    mockAppService.Setup(x => x.GetById(It.IsAny<int>(), false)).Returns(new App());
        //    MMappingExtensions.ToModelApp = (ent) => { return new AppModel(); };

        //    var result = target.Update(Stubs.GetFakeAppModel()) as RedirectToRouteResult;

        //    Assert.Equal("List", result.RouteValues["action"]);
        //}
    }
}
