﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit;
using System.Reflection;
using Microsoft.Moles.Framework;

namespace Weapsy.Apps.Forum.Tests.TestAttributes
{
    public sealed class MoledAttribute
        : BeforeAfterTestAttribute
    {
        IDisposable _molesContext;

        /// <summary>
        /// Creates the mole runtime context
        /// </summary>
        /// <param name="methodUnderTest"></param>
        public override void Before(MethodInfo methodUnderTest)
        {
            this._molesContext = MolesContext.Create();
        }

        /// <summary>
        /// Disposes the mole runtime context
        /// </summary>
        /// <param name="methodUnderTest"></param>
        public override void After(MethodInfo methodUnderTest)
        {
            var disposable = this._molesContext;
            if (disposable != null)
                disposable.Dispose();
            this._molesContext = null;
        }
    }
}
