#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Configuration.Provider;
using System.IO;
using System.Runtime.CompilerServices;
using System.Web;
using System.Web.Caching;
using System.Web.Configuration;
using System.Collections.Generic;
using System.Text;

namespace Weapsy
{

	public class Utils
	{
        public static bool HasPermission(string roles)
        {
            bool result = false;
            if (!string.IsNullOrEmpty(roles)) {
                foreach (string role in roles.Split(",".ToCharArray())) {
                    if (!string.IsNullOrEmpty(role)) {
                        if (role == Consts.RoleAll ||
                            HttpContext.Current.Request.IsAuthenticated == true && role == Consts.RoleRegistered ||
                            HttpContext.Current.Request.IsAuthenticated == false && role == Consts.RoleAnonymous ||
                            System.Web.Security.Roles.IsUserInRole(role))
                        {
                            result = true;
                            break;
                        }
                    }
                }
            }
            return result;
        }

        public static string Choose(string FirstChoise, string SecondChoice)
        {
            if (!string.IsNullOrEmpty(FirstChoise)) return FirstChoise;
            if (!string.IsNullOrEmpty(SecondChoice)) return SecondChoice;
            return string.Empty;
        }

        public static string Choose(string FirstChoise, string SecondChoice, string ThirdChoice)
        {
            if (!string.IsNullOrEmpty(FirstChoise)) return FirstChoise;
            if (!string.IsNullOrEmpty(SecondChoice)) return SecondChoice;
            if (!string.IsNullOrEmpty(ThirdChoice)) return ThirdChoice;
            return string.Empty;
        }

        public static string Choose(string FirstChoise, string SecondChoice, string ThirdChoice, string FourthChoice)
        {
            if (!string.IsNullOrEmpty(FirstChoise)) return FirstChoise;
            if (!string.IsNullOrEmpty(SecondChoice)) return SecondChoice;
            if (!string.IsNullOrEmpty(ThirdChoice)) return ThirdChoice;
            if (!string.IsNullOrEmpty(FourthChoice)) return FourthChoice;
            return string.Empty;
        }

		public static DateTime GetNullDateTime()
		{
			return new DateTime(1754, 1, 1, 0, 0, 0, 0);
		}

        public static DateTime GetDateForDB()
        {
            return DateTime.UtcNow;
        }

		public static void RestartApplication()
		{
			File.SetLastWriteTime(HttpContext.Current.Request.MapPath("~\\Web.config"), System.DateTime.Now);
		}

		public static string ReadFile(string FileName)
		{
			StreamReader objStreamReader = new StreamReader(HttpContext.Current.Server.MapPath(FileName));
			string strFileContent = objStreamReader.ReadToEnd();
			objStreamReader.Close();
			return strFileContent;
		}

		public static Dictionary<int, string> GetDays()
		{
			Dictionary<int, string> Result = new Dictionary<int, string>();
			Result.Add(0, "");
            int i;
			for (i = 1; i <= 31; i++) {
				Result.Add(i, i.ToString());
			}
			return Result;
		}

		public static Dictionary<int, string> GetMounths()
		{
			Dictionary<int, string> Result = new Dictionary<int, string>();
			Result.Add(0, "");
			Result.Add(1, "January");
			Result.Add(2, "Febraury");
			Result.Add(3, "March");
			Result.Add(4, "April");
			Result.Add(5, "May");
			Result.Add(6, "June");
			Result.Add(7, "July");
			Result.Add(8, "August");
			Result.Add(9, "September");
			Result.Add(10, "October");
			Result.Add(11, "November");
			Result.Add(12, "December");
			return Result;
		}

		public static Dictionary<int, string> GetYears()
		{
			Dictionary<int, string> Result = new Dictionary<int, string>();
			Result.Add(0, "");
            int i;
			for (i = 1900; i <= DateTime.Now.Year; i++) {
				Result.Add(i, i.ToString());
			}
			return Result;
		}

		public static Dictionary<int, string> GetGenders()
		{
			Dictionary<int, string> Result = new Dictionary<int, string>();
			Result.Add(0, "");
			Result.Add(1, "M");
			Result.Add(2, "F");
			return Result;
		}

	#region Strings

		public static string ParseTextForUrl(string txt)
		{
			if (string.IsNullOrEmpty(txt)) {
				return string.Empty;
			}
			txt = txt.Replace(":", string.Empty);
			txt = txt.Replace(";", string.Empty);
			txt = txt.Replace("/", string.Empty);
			txt = txt.Replace("\\", string.Empty);
			txt = txt.Replace("|", string.Empty);
			txt = txt.Replace("!", string.Empty);
			txt = txt.Replace("?", string.Empty);
			txt = txt.Replace("#", string.Empty);
			txt = txt.Replace("(", string.Empty);
			txt = txt.Replace(")", string.Empty);
			txt = txt.Replace("[", string.Empty);
			txt = txt.Replace("]", string.Empty);
			txt = txt.Replace("{", string.Empty);
			txt = txt.Replace("}", string.Empty);
			txt = txt.Replace("@", string.Empty);
			txt = txt.Replace("*", string.Empty);
			txt = txt.Replace(".", string.Empty);
			txt = txt.Replace(",", string.Empty);
			txt = txt.Replace("\"", string.Empty);
			txt = txt.Replace("&", string.Empty);
			txt = txt.Replace("'", string.Empty);
			txt = txt.Replace(" ", "-");
			txt = RemoveDiacritics(txt);
			txt = RemoveExtraHyphen(txt);
			return HttpUtility.UrlEncode(txt).Replace("%", string.Empty).ToLower();
		}

        private static string RemoveDiacritics(string txt)
        {
            string normalized = txt.Normalize(NormalizationForm.FormD);
            StringBuilder sb = new StringBuilder();
            int i = 0;
            for (i = 0; i <= normalized.Length - 1; i++)
            {
                char c = (char)normalized[i];
                if ((System.Globalization.CharUnicodeInfo.GetUnicodeCategory(c) != System.Globalization.UnicodeCategory.NonSpacingMark))
                {
                    sb.Append(c);
                }
            }
            return sb.ToString();
        }

        private static string RemoveExtraHyphen(string txt)
        {
            if (txt.Contains("--"))
            {
                txt = txt.Replace("--", "-");
                return Utils.RemoveExtraHyphen(txt);
            }
            return txt;
        }

	#endregion

        public static bool CheckBoxChecked(string key, string values)
        {
            if (!string.IsNullOrEmpty(values))
            {
                foreach (string value in values.Split(",".ToCharArray()))
                {
                    if (!string.IsNullOrEmpty(value) && value == key)
                    {
                        return true;
                    }
                }
            }
            return false;
        }

        public static bool CheckBoxChecked(string key, string[] values)
        {
            foreach (string value in values)
            {
                if (!string.IsNullOrEmpty(value) && value == key)
                {
                    return true;
                }
            }
            return false;
        }

        public static object RoleCheckBoxDisabled(string key)
        {
            object result = null;

            if (!string.IsNullOrEmpty(key))
            {
                if (key == AppSettings.RoleAdmin | key == AppSettings.RoleSuperAdmin)
                {
                    result = new { disabled = "disabled" };
                }
            }

            return result;
        }

	}

}
