﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Web.Management;

namespace Weapsy.Data.Initializers
{
    public class ValidateDatabaseInitializer<TContext> : IDatabaseInitializer<TContext> where TContext : DbContext
    {
        public void InitializeDatabase(TContext context)
        {
            if (!context.Database.Exists())
            {
                throw new InvalidOperationException(
                  "Database does not exist");
            }
            else
            {
                if (!context.Database.CompatibleWithModel(true))
                {
                    throw new InvalidOperationException(
                      "The database is not compatible with the entity model.");
                }
            }
        }
    }

}