﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class AppMap : EntityTypeConfiguration<Entities.App>
    {
        public AppMap()
        {
            this.ToTable("App");

            this.HasKey(a => a.Id);

            this.Property(a => a.Name).IsRequired().HasMaxLength(100);
            this.Property(a => a.Title).IsRequired().HasMaxLength(100);
            this.Property(a => a.Description).HasMaxLength(2000);
            this.Property(a => a.Folder).IsRequired().HasMaxLength(100);
            this.Property(a => a.Url).IsRequired().HasMaxLength(100);
            this.Property(a => a.AdminController).IsRequired().HasMaxLength(100);
            this.Property(a => a.AdminAction).IsRequired().HasMaxLength(100);
            this.Property(a => a.DashboardIcon).HasMaxLength(100);
            this.Property(a => a.Deleted).IsRequired();
            this.Property(a => a.CreatedByUserId).IsRequired();
            this.Property(a => a.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(a => a.CreatedOnDate).IsRequired();
            this.Property(a => a.ModifiedByUserId).IsRequired();
            this.Property(a => a.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(a => a.ModifiedOnDate).IsRequired();
        }
    }
}