﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumCategoryMap : EntityTypeConfiguration<ForumCategory>
    {
        public ForumCategoryMap()
        {
            this.ToTable("ForumCategory");

            this.HasKey(c => c.Id);

            this.Property(c => c.ConfigurationId).IsRequired();
            this.Property(c => c.Name).IsRequired().HasMaxLength(100);
            this.Property(c => c.Url).IsRequired().HasMaxLength(100);
            this.Property(c => c.Description).HasMaxLength(2000);
            this.Property(c => c.Notes).IsMaxLength();
            this.Property(c => c.SortOrder).IsRequired();
            this.Property(c => c.IconImage).HasMaxLength(100);
            this.Property(c => c.NameImage).HasMaxLength(100);
            this.Property(c => c.Closed).IsRequired();
            this.Property(c => c.Active).IsRequired();
            this.Property(c => c.Deleted).IsRequired();
            this.Property(c => c.SettingSetId).IsRequired();
            this.Property(c => c.PermissionSetId).IsRequired();
            this.Property(c => c.Topics).IsRequired();
            this.Property(c => c.Replies).IsRequired();
            this.Property(c => c.Authorized).HasMaxLength(1000);
            this.Property(c => c.CreatedByUserId).IsRequired();
            this.Property(c => c.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(c => c.CreatedOnDate).IsRequired();
            this.Property(c => c.ModifiedByUserId).IsRequired();
            this.Property(c => c.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(c => c.ModifiedOnDate).IsRequired();

            this.HasRequired(c => c.Configuration)
                .WithMany(config => config.Categories)
                .HasForeignKey(c => c.ConfigurationId);
        }
    }
}