﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumConfigurationMap : EntityTypeConfiguration<ForumConfiguration>
    {
        public ForumConfigurationMap()
        {
            this.ToTable("ForumConfiguration");

            this.HasKey(c => c.Id);

            this.Property(c => c.SiteId).IsRequired();
            this.Property(c => c.Name).IsRequired().HasMaxLength(100);
            this.Property(c => c.Description).HasMaxLength(250);
            this.Property(c => c.Enabled).IsRequired();
            this.Property(c => c.SettingSetId).IsRequired();
            this.Property(c => c.PermissionSetId).IsRequired();
            this.Property(c => c.CreatedByUserId).IsRequired();
            this.Property(c => c.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(c => c.CreatedOnDate).IsRequired();
            this.Property(c => c.ModifiedByUserId).IsRequired();
            this.Property(c => c.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(c => c.ModifiedOnDate).IsRequired();

            this.HasRequired(c => c.Site)
                .WithMany(s => s.ForumConfigurations)
                .HasForeignKey(c => c.SiteId);
        }
    }
}