﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumPermissionSetMap : EntityTypeConfiguration<ForumPermissionSet>
    {
        public ForumPermissionSetMap()
        {
            this.ToTable("ForumPermissionSet");

            this.HasKey(p => p.Id);

            this.Property(p => p.ConfigurationId).IsRequired();
            this.Property(p => p.Name).IsRequired().HasMaxLength(100);
            this.Property(p => p.Description).HasMaxLength(250);
            this.Property(p => p.ViewSection).HasMaxLength(1000);
            this.Property(p => p.ViewTopics).HasMaxLength(1000);
            this.Property(p => p.Read).HasMaxLength(1000);
            this.Property(p => p.Start).HasMaxLength(1000);
            this.Property(p => p.Reply).HasMaxLength(1000);
            this.Property(p => p.Upload).HasMaxLength(1000);
            this.Property(p => p.Download).HasMaxLength(1000);
            this.Property(p => p.SubscribeSection).HasMaxLength(1000);
            this.Property(p => p.SubscribeTopic).HasMaxLength(1000);
            this.Property(p => p.Edit).HasMaxLength(1000);
            this.Property(p => p.Delete).HasMaxLength(1000);
            this.Property(p => p.Pin).HasMaxLength(1000);
            this.Property(p => p.Lock).HasMaxLength(1000);
            this.Property(p => p.Moderate).HasMaxLength(1000);
            this.Property(p => p.VotePoll).HasMaxLength(1000);
            this.Property(p => p.CreatePoll).HasMaxLength(1000);
            this.Property(p => p.SelectStatus).HasMaxLength(1000);
            this.Property(p => p.Announce).HasMaxLength(1000);
            this.Property(p => p.RateTopics).HasMaxLength(1000);
            this.Property(p => p.CreatedByUserId).IsRequired();
            this.Property(p => p.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.CreatedOnDate).IsRequired();
            this.Property(p => p.ModifiedByUserId).IsRequired();
            this.Property(p => p.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.ModifiedOnDate).IsRequired();

            this.HasRequired(p => p.Configuration)
                .WithMany(c => c.PermissionSets)
                .HasForeignKey(p => p.ConfigurationId);
        }
    }
}