﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumPostMap : EntityTypeConfiguration<ForumPost>
    {
        public ForumPostMap()
        {
            this.ToTable("ForumPost");

            this.HasKey(p => p.Id);

            this.Property(p => p.SectionId).IsRequired();
            this.Property(p => p.ParentId).IsRequired();
            this.Property(p => p.Title).IsRequired().HasMaxLength(100);
            this.Property(p => p.Url).IsRequired().HasMaxLength(100);
            this.Property(p => p.Body).IsMaxLength();
            this.Property(p => p.IconImage).HasMaxLength(100);
            this.Property(p => p.Pinned).IsRequired();
            this.Property(p => p.Locked).IsRequired();
            this.Property(p => p.LastReplyId);
            this.Property(p => p.Replies).IsRequired();
            this.Property(p => p.Views).IsRequired();

            this.Property(p => p.Moved).IsRequired();
            this.Property(p => p.MovedByUserId);
            this.Property(p => p.MovedFromSectionId);
            this.Property(p => p.MovedByIpAddress);
            this.Property(p => p.MovedOnDate);

            this.Property(p => p.Deleted).IsRequired();
            this.Property(p => p.DeletedByUserId);
            this.Property(p => p.DeletedByIpAddress);
            this.Property(p => p.DeletedOnDate);

            this.Property(p => p.CreatedByUserId).IsRequired();
            this.Property(p => p.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.CreatedOnDate).IsRequired();

            this.Property(p => p.ModifiedByUserId).IsRequired();
            this.Property(p => p.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.ModifiedOnDate).IsRequired();

            this.HasRequired(p => p.Section)
                .WithMany(s => s.Posts)
                .HasForeignKey(p => p.SectionId);

            this.HasRequired(p => p.Parent)
                .WithMany(t => t.Posts)
                .HasForeignKey(p => p.ParentId);

            this.HasRequired(p => p.CreatedByUser)
                .WithMany(fu => fu.Posts)
                .HasForeignKey(p => p.CreatedByUserId)
                .WillCascadeOnDelete(false);
        }
    }
}