﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumSectionMap : EntityTypeConfiguration<ForumSection>
    {
        public ForumSectionMap()
        {
            this.ToTable("ForumSection");

            this.HasKey(s => s.Id);

            this.Property(s => s.CategoryId).IsRequired();
            this.Property(s => s.Name).IsRequired().HasMaxLength(100);
            this.Property(s => s.Url).IsRequired().HasMaxLength(100);
            this.Property(s => s.Description).HasMaxLength(2000);
            this.Property(s => s.Notes).IsMaxLength();
            this.Property(s => s.ParentId).IsRequired();
            this.Property(s => s.SortOrder).IsRequired();
            this.Property(s => s.IconImage).HasMaxLength(100);
            this.Property(s => s.NameImage).HasMaxLength(100);
            this.Property(s => s.SectionImage).HasMaxLength(100);
            this.Property(s => s.Type).IsRequired();
            this.Property(s => s.Closed).IsRequired();
            this.Property(s => s.Active).IsRequired();
            this.Property(s => s.Deleted).IsRequired();
            this.Property(s => s.SettingSetId).IsRequired();
            this.Property(s => s.PermissionSetId).IsRequired();
            this.Property(s => s.Topics).IsRequired();
            this.Property(s => s.Replies).IsRequired();
            this.Property(s => s.LastPostId).IsRequired();
            this.Property(s => s.CreatedByUserId).IsRequired();
            this.Property(s => s.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.CreatedOnDate).IsRequired();
            this.Property(s => s.ModifiedByUserId).IsRequired();
            this.Property(s => s.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.ModifiedOnDate).IsRequired();

            this.HasRequired(s => s.Category)
                .WithMany(c => c.Sections)
                .HasForeignKey(s => s.CategoryId);
        }
    }
}