﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumSettingSetMap : EntityTypeConfiguration<ForumSettingSet>
    {
        public ForumSettingSetMap()
        {
            this.ToTable("ForumSettingSet");

            this.HasKey(s => s.Id);

            this.Property(s => s.ConfigurationId).IsRequired();
            this.Property(s => s.Name).IsRequired().HasMaxLength(100);
            this.Property(s => s.Description).HasMaxLength(250);
            this.Property(s => s.ModerateTopics).IsRequired();
            this.Property(s => s.ModerateTopicsExcluded).HasMaxLength(1000);
            this.Property(s => s.ModerateReplies).IsRequired();
            this.Property(s => s.ModerateRepliesExcluded).HasMaxLength(1000);
            //this.Property(s => s.SubscribeSection).IsRequired();
            //this.Property(s => s.SubscribeTopic).IsRequired();
            //this.Property(s => s.Emoticons).IsRequired();
            //this.Property(s => s.PostIcon).IsRequired();
            //this.Property(s => s.Attachments).IsRequired();
            //this.Property(s => s.TopicRating).IsRequired();
            //this.Property(s => s.RSS).IsRequired();
            //this.Property(s => s.Polls).IsRequired();
            //this.Property(s => s.StatusSelection).IsRequired();
            //this.Property(s => s.QuickReply).IsRequired();
            //this.Property(s => s.PostIconDisplayDefault).IsRequired();
            //this.Property(s => s.PostIconRequired).IsRequired();
            //this.Property(s => s.StatusRequired).IsRequired();
            //this.Property(s => s.TopicsSortOrder).IsRequired();
            //this.Property(s => s.TopicsSortField).IsRequired();
            //this.Property(s => s.TopicsSortFilter).IsRequired();
            //this.Property(s => s.AttachMaxNumber).IsRequired();
            //this.Property(s => s.AttachMaxSize).IsRequired();
            //this.Property(s => s.AttachTypes).IsRequired();
            //this.Property(s => s.AttachMaxNumber).IsRequired();
            //this.Property(s => s.AttachMaxImgWidth).IsRequired();
            //this.Property(s => s.AttachMaxImgHeight).IsRequired();
            //this.Property(s => s.AttachMaxImgThumbWidth).IsRequired();
            //this.Property(s => s.AttachMaxImgThumbHeight).IsRequired();
            //this.Property(s => s.PostEditRestrictionEnabled).IsRequired();
            //this.Property(s => s.PostEditRestrictionInterval).IsRequired();
            //this.Property(s => s.PostEditRestrictionExcluded).HasMaxLength(1000);
            //this.Property(s => s.PostEditReasonEnabled).IsRequired();
            //this.Property(s => s.PostEditReasonRequired).IsRequired();
            //this.Property(s => s.PostEditReasonExcluded).HasMaxLength(1000);
            this.Property(s => s.CreatedByUserId).IsRequired();
            this.Property(s => s.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.CreatedOnDate).IsRequired();
            this.Property(s => s.ModifiedByUserId).IsRequired();
            this.Property(s => s.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.ModifiedOnDate).IsRequired();

            this.HasRequired(p => p.Configuration)
                .WithMany(c => c.SettingSets)
                .HasForeignKey(p => p.ConfigurationId);
        }
    }
}