﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Data.Mapping
{
    public partial class ForumUserMap : EntityTypeConfiguration<ForumUser>
    {
        public ForumUserMap()
        {
            this.ToTable("ForumUser");

            this.HasKey(u => u.Id);

            this.Property(u => u.UserId).IsRequired();
            this.Property(u => u.Topics).IsRequired();
            this.Property(u => u.Replies).IsRequired();
            this.Property(u => u.LastTopicId).IsRequired();
            this.Property(u => u.LastReplyId).IsRequired();
            this.Property(u => u.BannedUntil);

            this.HasRequired(u => u.User)
                .WithMany(t => t.ForumUsers)
                .HasForeignKey(u => u.UserId);
        }
    }
}