﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class EmailAccountMap : EntityTypeConfiguration<EmailAccount>
    {
        public EmailAccountMap()
        {
            this.ToTable("EmailAccount");

            this.HasKey(ea => ea.Id);

            this.Property(ea => ea.SiteId).IsRequired();
            this.Property(ea => ea.Address).IsRequired().HasMaxLength(250);
            this.Property(ea => ea.DisplayName).HasMaxLength(100);
            this.Property(ea => ea.Host).IsRequired().HasMaxLength(250);
            this.Property(ea => ea.Port).IsRequired();
            this.Property(ea => ea.UserName).HasMaxLength(250);
            this.Property(ea => ea.Password).HasMaxLength(250);
            this.Property(ea => ea.DefaultCredentials).IsRequired();
            this.Property(ea => ea.Ssl).IsRequired();
            this.Property(ea => ea.Deleted).IsRequired();
            this.Property(ea => ea.CreatedByUserId).IsRequired();
            this.Property(ea => ea.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(ea => ea.CreatedOnDate).IsRequired();
            this.Property(ea => ea.ModifiedByUserId).IsRequired();
            this.Property(ea => ea.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(ea => ea.ModifiedOnDate).IsRequired();
        }
    }
}