﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LanguageMap : EntityTypeConfiguration<Language>
    {
        public LanguageMap()
        {
            this.ToTable("Language");

            this.HasKey(l => l.Id);

            this.Property(l => l.SiteId).IsRequired();
            this.Property(l => l.Name).IsRequired().HasMaxLength(100);
            this.Property(l => l.CultureName).IsRequired().HasMaxLength(50);
            this.Property(l => l.CultureNativeName).IsRequired().HasMaxLength(200);
            this.Property(l => l.CultureEnglishName).IsRequired().HasMaxLength(200);
            this.Property(l => l.Url).IsRequired().HasMaxLength(50);
            this.Property(l => l.Flag).HasMaxLength(100);
            this.Property(l => l.Active).IsRequired();
            this.Property(l => l.SortOrder).IsRequired();
            this.Property(l => l.Deleted).IsRequired();
            this.Property(l => l.CreatedByUserId).IsRequired();
            this.Property(l => l.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(l => l.CreatedOnDate).IsRequired();
            this.Property(l => l.ModifiedByUserId).IsRequired();
            this.Property(l => l.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(l => l.ModifiedOnDate).IsRequired();

            this.HasRequired(l => l.Site)
                .WithMany(s => s.Languages)
                .HasForeignKey(l => l.SiteId)
                .WillCascadeOnDelete(false);
        }
    }
}