﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedMailTemplateMap : EntityTypeConfiguration<LocalizedMailTemplate>
    {
        public LocalizedMailTemplateMap()
        {
            this.ToTable("LocalizedMailTemplate");

            this.HasKey(lmt => lmt.Id);

            this.Property(lmt => lmt.MailTemplateId).IsRequired();
            this.Property(lmt => lmt.LanguageId).IsRequired();
            this.Property(lmt => lmt.Subject).HasMaxLength(250);
            this.Property(lmt => lmt.BodyHtml).IsMaxLength();
            this.Property(lmt => lmt.BodyPlain).IsMaxLength();

            this.HasRequired(lmt => lmt.MailTemplate)
                .WithMany(mt => mt.LocalizedMailTemplates)
                .HasForeignKey(lmt => lmt.MailTemplateId);

            this.HasRequired(lmt => lmt.Language)
                .WithMany(l => l.LocalizedMailTemplates)
                .HasForeignKey(lmt => lmt.LanguageId);
        }
    }
}