﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedModuleMap : EntityTypeConfiguration<LocalizedModule>
    {
        public LocalizedModuleMap()
        {
            this.ToTable("LocalizedModule");

            this.HasKey(lm => lm.Id);

            this.Property(lm => lm.ModuleId).IsRequired();
            this.Property(lm => lm.LanguageId).IsRequired();
            this.Property(lm => lm.Title).HasMaxLength(100);

            this.HasRequired(lm => lm.Module)
                .WithMany(m => m.LocalizedModules)
                .HasForeignKey(lm => lm.ModuleId);

            this.HasRequired(lm => lm.Language)
                .WithMany(l => l.LocalizedModules)
                .HasForeignKey(lm => lm.LanguageId);
        }
    }
}