﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedPageMap : EntityTypeConfiguration<LocalizedPage>
    {
        public LocalizedPageMap()
        {
            this.ToTable("LocalizedPage");

            this.HasKey(lp => lp.Id);

            this.Property(lp => lp.PageId).IsRequired();
            this.Property(lp => lp.LanguageId).IsRequired();
            this.Property(lp => lp.Url).HasMaxLength(200);
            this.Property(lp => lp.PageTitle).HasMaxLength(100);
            this.Property(lp => lp.PageImage).HasMaxLength(256);
            this.Property(lp => lp.MenuText).HasMaxLength(100);
            this.Property(lp => lp.MenuTitle).HasMaxLength(250);
            this.Property(lp => lp.MenuImage).HasMaxLength(256);
            this.Property(lp => lp.MetaTitle).HasMaxLength(250);
            this.Property(lp => lp.MetaDescription).HasMaxLength(500);
            this.Property(lp => lp.MetaKeywords).HasMaxLength(500);
            this.Property(lp => lp.Body).IsMaxLength();

            this.HasRequired(lp => lp.Page)
                .WithMany(p => p.LocalizedPages)
                .HasForeignKey(lp => lp.PageId);

            this.HasRequired(lp => lp.Language)
                .WithMany(l => l.LocalizedPages)
                .HasForeignKey(lp => lp.LanguageId);
        }
    }
}