﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedPageModuleMap : EntityTypeConfiguration<LocalizedPageModule>
    {
        public LocalizedPageModuleMap()
        {
            this.ToTable("LocalizedPageModule");

            this.HasKey(lpm => lpm.Id);

            this.Property(lpm => lpm.PageModuleId).IsRequired();
            this.Property(lpm => lpm.LanguageId).IsRequired();
            this.Property(lpm => lpm.Title).HasMaxLength(100);

            this.HasRequired(lpm => lpm.PageModule)
                .WithMany(pm => pm.LocalizedPageModules)
                .HasForeignKey(lpm => lpm.PageModuleId);

            this.HasRequired(lpm => lpm.Language)
                .WithMany(l => l.LocalizedPageModules)
                .HasForeignKey(lpm => lpm.LanguageId);
        }
    }
}