﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedPluginMap : EntityTypeConfiguration<LocalizedPlugin>
    {
        public LocalizedPluginMap()
        {
            this.ToTable("LocalizedPlugin");

            this.HasKey(lp => lp.Id);

            this.Property(lp => lp.PluginId).IsRequired();
            this.Property(lp => lp.LanguageId).IsRequired();
            this.Property(lp => lp.DashboardText).HasMaxLength(100);
            this.Property(lp => lp.DashboardTitle).HasMaxLength(250);
            this.Property(lp => lp.MenuText).HasMaxLength(100);
            this.Property(lp => lp.MenuTitle).HasMaxLength(250);

            this.HasRequired(lp => lp.Plugin)
                .WithMany(p => p.LocalizedPlugins)
                .HasForeignKey(lp => lp.PluginId);

            this.HasRequired(lp => lp.Language)
                .WithMany(l => l.LocalizedPlugins)
                .HasForeignKey(lp => lp.LanguageId);
        }
    }
}