﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedSiteMap : EntityTypeConfiguration<LocalizedSite>
    {
        public LocalizedSiteMap()
        {
            this.ToTable("LocalizedSite");

            this.HasKey(ls => ls.Id);

            this.Property(ls => ls.SiteId).IsRequired();
            this.Property(ls => ls.LanguageId).IsRequired();
            this.Property(ls => ls.Title).HasMaxLength(100);
            this.Property(ls => ls.MetaTitle).HasMaxLength(250);
            this.Property(ls => ls.MetaDescription).HasMaxLength(500);
            this.Property(ls => ls.MetaKeywords).HasMaxLength(500);

            this.HasRequired(ls => ls.Site)
                .WithMany(s => s.LocalizedSites)
                .HasForeignKey(ls => ls.SiteId)
                .WillCascadeOnDelete(false);

            this.HasRequired(ls => ls.Language)
                .WithMany(l => l.LocalizedSites)
                .HasForeignKey(ls => ls.LanguageId);
        }
    }
}