﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedTextVersionMap : EntityTypeConfiguration<LocalizedTextVersion>
    {
        public LocalizedTextVersionMap()
        {
            this.ToTable("LocalizedTextVersion");

            this.HasKey(ltv => ltv.Id);

            this.Property(ltv => ltv.TextVersionId).IsRequired();
            this.Property(ltv => ltv.LanguageId).IsRequired();
            this.Property(ltv => ltv.Body).IsMaxLength();

            this.HasRequired(ltv => ltv.TextVersion)
                .WithMany(tv => tv.LocalizedTextVersions)
                .HasForeignKey(ltv => ltv.TextVersionId);

            this.HasRequired(ltv => ltv.Language)
                .WithMany(l => l.LocalizedTextVersions)
                .HasForeignKey(ltv => ltv.LanguageId);
        }
    }
}