﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class LocalizedWidgetMap : EntityTypeConfiguration<LocalizedWidget>
    {
        public LocalizedWidgetMap()
        {
            this.ToTable("LocalizedWidget");

            this.HasKey(lw => lw.Id);

            this.Property(lw => lw.WidgetId).IsRequired();
            this.Property(lw => lw.LanguageId).IsRequired();
            this.Property(lw => lw.Title).HasMaxLength(100);

            this.HasRequired(lw => lw.Widget)
                .WithMany(p => p.LocalizedWidgets)
                .HasForeignKey(lw => lw.WidgetId);

            this.HasRequired(lw => lw.Language)
                .WithMany(l => l.LocalizedWidgets)
                .HasForeignKey(lw => lw.LanguageId);
        }
    }
}