﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class MailTemplateMap : EntityTypeConfiguration<MailTemplate>
    {
        public MailTemplateMap()
        {
            this.ToTable("MailTemplate");

            this.HasKey(mt => mt.Id);

            this.Property(mt => mt.MailTemplateTypeId).IsRequired();
            this.Property(mt => mt.SiteId).IsRequired();
            this.Property(mt => mt.Name).IsRequired().HasMaxLength(100);
            this.Property(mt => mt.Description).HasMaxLength(250);
            this.Property(mt => mt.Subject).IsRequired().HasMaxLength(250);
            this.Property(mt => mt.BodyHtml).IsRequired().IsMaxLength();
            this.Property(mt => mt.BodyPlain).IsRequired().IsMaxLength();
            this.Property(mt => mt.Deleted).IsRequired();
            this.Property(mt => mt.CreatedByUserId).IsRequired();
            this.Property(mt => mt.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mt => mt.CreatedOnDate).IsRequired();
            this.Property(mt => mt.ModifiedByUserId).IsRequired();
            this.Property(mt => mt.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mt => mt.ModifiedOnDate).IsRequired();

            this.HasRequired(mt => mt.MailTemplateType)
                .WithMany(mtt => mtt.MailTemplates)
                .HasForeignKey(mt => mt.MailTemplateTypeId);

            this.HasRequired(mt => mt.Site)
                .WithMany(s => s.MailTemplates)
                .HasForeignKey(mt => mt.SiteId);

            this.Ignore(mt => mt.LocalizedSubject);
            this.Ignore(mt => mt.LocalizedBodyHtml);
            this.Ignore(mt => mt.LocalizedBodyPlain);
        }
    }
}