﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class MailTemplateTypeMap : EntityTypeConfiguration<MailTemplateType>
    {
        public MailTemplateTypeMap()
        {
            this.ToTable("MailTemplateType");

            this.HasKey(mtt => mtt.Id);

            this.Property(mtt => mtt.AppId).IsRequired();
            this.Property(mtt => mtt.Name).IsRequired().HasMaxLength(100);
            this.Property(mtt => mtt.Description).HasMaxLength(250);
            this.Property(mtt => mtt.TokenController).HasMaxLength(100);
            this.Property(mtt => mtt.TokenAction).HasMaxLength(100);
            this.Property(mtt => mtt.Deleted).IsRequired();
            this.Property(mtt => mtt.CreatedByUserId).IsRequired();
            this.Property(mtt => mtt.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mtt => mtt.CreatedOnDate).IsRequired();
            this.Property(mtt => mtt.ModifiedByUserId).IsRequired();
            this.Property(mtt => mtt.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mtt => mtt.ModifiedOnDate).IsRequired();
        }
    }
}