﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class ModuleDefinitionMap : EntityTypeConfiguration<ModuleDefinition>
    {
        public ModuleDefinitionMap()
        {
            this.ToTable("ModuleDefinition");

            this.HasKey(md => md.Id);

            this.Property(md => md.AppId).IsRequired();
            this.Property(md => md.Name).IsRequired().HasMaxLength(100);
            this.Property(md => md.Title).IsRequired().HasMaxLength(100);
            this.Property(md => md.Description).HasMaxLength(2000);
            this.Property(md => md.Controller).IsRequired().HasMaxLength(100);
            this.Property(md => md.Action).IsRequired().HasMaxLength(100);
            this.Property(md => md.AdminController).HasMaxLength(100);
            this.Property(md => md.AdminAction).HasMaxLength(100);
            this.Property(md => md.Deleted).IsRequired();
            this.Property(md => md.CreatedByUserId).IsRequired();
            this.Property(md => md.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(md => md.CreatedOnDate).IsRequired();
            this.Property(md => md.ModifiedByUserId).IsRequired();
            this.Property(md => md.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(md => md.ModifiedOnDate).IsRequired();
        }
    }
}