﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class ModuleMap : EntityTypeConfiguration<Module>
    {
        public ModuleMap()
        {
            this.ToTable("Module");

            this.HasKey(m => m.Id);

            this.Property(m => m.SiteId).IsRequired();
            this.Property(m => m.ModuleDefinitionId).IsRequired();
            this.Property(m => m.Title).IsRequired().HasMaxLength(100);
            this.Property(m => m.AllPages).IsRequired();
            this.Property(m => m.Deleted).IsRequired();
            this.Property(m => m.InheritPermissions).IsRequired();
            this.Property(m => m.Authorized).IsRequired().HasMaxLength(1000);
            this.Property(m => m.StartDate);
            this.Property(m => m.EndDate);
            this.Property(m => m.DisplayTitle).IsRequired();
            this.Property(m => m.Zone).IsRequired().HasMaxLength(100);
            this.Property(m => m.CreatedByUserId).IsRequired();
            this.Property(m => m.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(m => m.CreatedOnDate).IsRequired();
            this.Property(m => m.ModifiedByUserId).IsRequired();
            this.Property(m => m.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(m => m.ModifiedOnDate).IsRequired();

            this.HasRequired(m => m.Site)
                .WithMany(s => s.Modules)
                .HasForeignKey(m => m.SiteId);

            this.HasRequired(m => m.ModuleDefinition)
                .WithMany(md => md.Modules)
                .HasForeignKey(m => m.ModuleDefinitionId);

            this.Ignore(p => p.LocalizedTitle);
        }
    }
}