﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class ModuleTemplateMap : EntityTypeConfiguration<ModuleTemplate>
    {
        public ModuleTemplateMap()
        {
            this.ToTable("ModuleTemplate");

            this.HasKey(mt => mt.Id);

            this.Property(mt => mt.Name).IsRequired().HasMaxLength(100);
            this.Property(mt => mt.ViewName).IsRequired().HasMaxLength(100);
            this.Property(mt => mt.PreviewImage).HasMaxLength(100);
            this.Property(mt => mt.Deleted).IsRequired();
            this.Property(mt => mt.CreatedByUserId).IsRequired();
            this.Property(mt => mt.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mt => mt.CreatedOnDate).IsRequired();
            this.Property(mt => mt.ModifiedByUserId).IsRequired();
            this.Property(mt => mt.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(mt => mt.ModifiedOnDate).IsRequired();
        }
    }
}