﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class PageModuleMap : EntityTypeConfiguration<PageModule>
    {
        public PageModuleMap()
        {
            this.ToTable("PageModule");

            this.HasKey(pm => pm.Id);

            this.Property(pm => pm.PageId).IsRequired();
            this.Property(pm => pm.ModuleId).IsRequired();
            this.Property(pm => pm.Title).HasMaxLength(100);
            this.Property(pm => pm.Zone).IsRequired().HasMaxLength(100);
            this.Property(pm => pm.ModuleTemplateId).IsRequired();
            this.Property(pm => pm.SortOrder).IsRequired();
            this.Property(pm => pm.Deleted).IsRequired();
            this.Property(pm => pm.Icon).HasMaxLength(100);
            this.Property(pm => pm.CreatedByUserId).IsRequired();
            this.Property(pm => pm.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pm => pm.CreatedOnDate).IsRequired();
            this.Property(pm => pm.ModifiedByUserId).IsRequired();
            this.Property(pm => pm.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pm => pm.ModifiedOnDate).IsRequired();

            this.HasRequired(pm => pm.Page)
                .WithMany(p => p.PageModules)
                .HasForeignKey(pm => pm.PageId);

            this.HasRequired(pm => pm.Module)
                .WithMany(m => m.PageModules)
                .HasForeignKey(pm => pm.ModuleId);

            //this.HasOptional(pm => pm.ModuleTemplate)
            //    .WithMany(mt => mt.PageModules)
            //    .HasForeignKey(pm => pm.ModuleTemplateId);

            this.Ignore(p => p.LocalizedTitle);
        }
    }
}