﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class PageTemplateMap : EntityTypeConfiguration<PageTemplate>
    {
        public PageTemplateMap()
        {
            this.ToTable("PageTemplate");

            this.HasKey(pt => pt.Id);

            this.Property(pt => pt.Name).IsRequired().HasMaxLength(100);
            this.Property(pt => pt.ViewName).IsRequired().HasMaxLength(100);
            this.Property(pt => pt.Zones).IsRequired().HasMaxLength(250);
            this.Property(pt => pt.PreviewImage).HasMaxLength(100);
            this.Property(pt => pt.Deleted).IsRequired();
            this.Property(pt => pt.CreatedByUserId).IsRequired();
            this.Property(pt => pt.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pt => pt.CreatedOnDate).IsRequired();
            this.Property(pt => pt.ModifiedByUserId).IsRequired();
            this.Property(pt => pt.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pt => pt.ModifiedOnDate).IsRequired();
        }
    }
}