﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class PluginDefinitionMap : EntityTypeConfiguration<PluginDefinition>
    {
        public PluginDefinitionMap()
        {
            this.ToTable("PluginDefinition");

            this.HasKey(pd => pd.Id);

            this.Property(pd => pd.AppId).IsRequired();
            this.Property(pd => pd.Name).IsRequired().HasMaxLength(100);
            this.Property(pd => pd.Description).HasMaxLength(2000);
            this.Property(pd => pd.DashboardText).HasMaxLength(100);
            this.Property(pd => pd.DashboardTitle).HasMaxLength(250);
            this.Property(pd => pd.MenuText).HasMaxLength(100);
            this.Property(pd => pd.MenuTitle).HasMaxLength(250);
            this.Property(pd => pd.Controller).IsRequired().HasMaxLength(100);
            this.Property(pd => pd.Action).IsRequired().HasMaxLength(100);
            this.Property(pd => pd.AdminController).HasMaxLength(100);
            this.Property(pd => pd.AdminAction).HasMaxLength(100);
            this.Property(pd => pd.DashboardIcon).HasMaxLength(100);
            this.Property(pd => pd.MenuIcon).HasMaxLength(100);
            this.Property(pd => pd.TypeId).IsRequired();
            this.Property(pd => pd.Deleted).IsRequired();
            this.Property(pd => pd.CreatedByUserId).IsRequired();
            this.Property(pd => pd.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pd => pd.CreatedOnDate).IsRequired();
            this.Property(pd => pd.ModifiedByUserId).IsRequired();
            this.Property(pd => pd.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(pd => pd.ModifiedOnDate).IsRequired();
        }
    }
}