﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class PluginMap : EntityTypeConfiguration<Plugin>
    {
        public PluginMap()
        {
            this.ToTable("Plugin");

            this.HasKey(p => p.Id);

            this.Property(p => p.SiteId).IsRequired();
            this.Property(p => p.PluginDefinitionId).IsRequired();
            this.Property(p => p.DashboardText).HasMaxLength(100);
            this.Property(p => p.DashboardTitle).HasMaxLength(250);
            this.Property(p => p.MenuText).HasMaxLength(100);
            this.Property(p => p.MenuTitle).HasMaxLength(250);
            this.Property(p => p.Authorized).IsRequired().HasMaxLength(1000);
            this.Property(p => p.Active).IsRequired();
            this.Property(p => p.SortOrder).IsRequired();
            this.Property(p => p.Deleted).IsRequired();
            this.Property(p => p.CreatedByUserId).IsRequired();
            this.Property(p => p.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.CreatedOnDate).IsRequired();
            this.Property(p => p.ModifiedByUserId).IsRequired();
            this.Property(p => p.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(p => p.ModifiedOnDate).IsRequired();

            this.HasRequired(p => p.Site)
                .WithMany(s => s.Plugins)
                .HasForeignKey(p => p.SiteId);

            this.HasRequired(p => p.PluginDefinition)
                .WithMany(pd => pd.Plugins)
                .HasForeignKey(p => p.PluginDefinitionId);

            this.Ignore(p => p.LocalizedDashboardText);
            this.Ignore(p => p.LocalizedDashboardTitle);
            this.Ignore(p => p.LocalizedMenuText);
            this.Ignore(p => p.LocalizedMenuTitle);
        }
    }
}