﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class SiteMap : EntityTypeConfiguration<Site>
    {
        public SiteMap()
        {
            this.ToTable("Site");

            this.HasKey(s => s.Id);

            this.Property(s => s.Name).IsRequired().HasMaxLength(100);
            this.Property(s => s.HomePageId).IsRequired();
            this.Property(s => s.PageTemplateId).IsRequired();
            this.Property(s => s.ModuleTemplateId).IsRequired();
            this.Property(s => s.LanguageId).IsRequired();
            this.Property(s => s.LanguageSelectionEnabled).IsRequired();
            this.Property(s => s.LanguageUrlEnabled).IsRequired();
            this.Property(s => s.ThemeId).IsRequired();
            this.Property(s => s.Title).HasMaxLength(100);
            this.Property(s => s.MetaTitle).HasMaxLength(250);
            this.Property(s => s.MetaDescription).HasMaxLength(500);
            this.Property(s => s.MetaKeywords).HasMaxLength(500);
            this.Property(s => s.Closed).IsRequired();
            this.Property(s => s.Copyright).IsRequired().HasMaxLength(250);
            this.Property(s => s.Logo).HasMaxLength(100);
            this.Property(s => s.Url).HasMaxLength(250);
            this.Property(s => s.RegisterMailTemplateId).IsRequired();
            this.Property(s => s.PasswordRecoveryMailTemplateId).IsRequired();
            this.Property(s => s.ChangePasswordMailTemplateId).IsRequired();
            this.Property(s => s.RegisterEmailAccountId).IsRequired();
            this.Property(s => s.PasswordRecoveryEmailAccountId).IsRequired();
            this.Property(s => s.ChangePasswordEmailAccountId).IsRequired();
            this.Property(s => s.Deleted).IsRequired();
            this.Property(s => s.CreatedByUserId).IsRequired();
            this.Property(s => s.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.CreatedOnDate).IsRequired();
            this.Property(s => s.ModifiedByUserId).IsRequired();
            this.Property(s => s.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(s => s.ModifiedOnDate).IsRequired();

            //this.Property(s => s.AccountLayout).IsRequired().HasMaxLength(100);
            //this.Property(s => s.AdminLayout).IsRequired().HasMaxLength(100);
            //this.Property(s => s.AuthLayout).IsRequired().HasMaxLength(100);
            //this.Property(s => s.GroupLayout).IsRequired().HasMaxLength(100);
            //this.Property(s => s.ProfileLayout).IsRequired().HasMaxLength(100);
            //this.Property(s => s.SiteLayout).IsRequired().HasMaxLength(100);

            //this.HasOptional(s => s.HomePage)
            //    .WithRequired(hp => hp.Site)
            //    .WillCascadeOnDelete(false);

            //this.HasRequired(s => s.Theme)
            //    .WithMany(t => t.Sites)
            //    .HasForeignKey(s => s.ThemeId)
            //    .WillCascadeOnDelete(false);

            //this.HasRequired(s => s.PageTemplate)
            //    .WithMany(pt => pt.Sites)
            //    .HasForeignKey(s => s.PageTemplateId)
            //    .WillCascadeOnDelete(false);

            //this.HasRequired(s => s.ModuleTemplate)
            //    .WithMany(mt => mt.Sites)
            //    .HasForeignKey(s => s.ModuleTemplateId)
            //    .WillCascadeOnDelete(false);

            //this.HasOptional(s => s.Language)
            //    .WithRequired(l => l.Site)
            //    .WillCascadeOnDelete(false);
        }
    }
}