﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class TextMap : EntityTypeConfiguration<Text>
    {
        public TextMap()
        {
            this.ToTable("Text");

            this.HasKey(t => t.Id);

            this.Property(t => t.ModuleId).IsRequired();
            this.Property(t => t.TextVersionId).IsRequired();
            this.Property(t => t.CreatedByUserId).IsRequired();
            this.Property(t => t.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(t => t.CreatedOnDate).IsRequired();
            this.Property(t => t.ModifiedByUserId).IsRequired();
            this.Property(t => t.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(t => t.ModifiedOnDate).IsRequired();

            this.HasRequired(t => t.Module)
                .WithMany(m => m.Texts)
                .HasForeignKey(t => t.ModuleId);

            //this.HasOptional(t => t.TextVersion)
            //    .WithRequired(tv => tv.Text)
            //    .WillCascadeOnDelete(false);
        }
    }
}