﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class TextVersionMap : EntityTypeConfiguration<TextVersion>
    {
        public TextVersionMap()
        {
            this.ToTable("TextVersion");

            this.HasKey(tv => tv.Id);

            this.Property(tv => tv.TextId).IsRequired();
            this.Property(tv => tv.Description).HasMaxLength(250);
            this.Property(tv => tv.Body).IsMaxLength();
            this.Property(tv => tv.CreatedByUserId).IsRequired();
            this.Property(tv => tv.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(tv => tv.CreatedOnDate).IsRequired();
            this.Property(tv => tv.ModifiedByUserId).IsRequired();
            this.Property(tv => tv.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(tv => tv.ModifiedOnDate).IsRequired();

            this.HasRequired(tv => tv.Text)
                .WithMany(t => t.TextVersions)
                .HasForeignKey(tv => tv.TextId);
        }
    }
}