﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class ThemeMap : EntityTypeConfiguration<Theme>
    {
        public ThemeMap()
        {
            this.ToTable("Theme");

            this.HasKey(t => t.Id);

            this.Property(t => t.Name).IsRequired().HasMaxLength(100);
            this.Property(t => t.Description).HasMaxLength(250);
            this.Property(t => t.Folder).IsRequired().HasMaxLength(100);
            this.Property(t => t.PreviewImage).HasMaxLength(100);
            this.Property(t => t.SortOrder).IsRequired();
            this.Property(t => t.Deleted).IsRequired();
            this.Property(t => t.CreatedByUserId).IsRequired();
            this.Property(t => t.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(t => t.CreatedOnDate).IsRequired();
            this.Property(t => t.ModifiedByUserId).IsRequired();
            this.Property(t => t.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(t => t.ModifiedOnDate).IsRequired();
        }
    }
}