﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class UserMap : EntityTypeConfiguration<User>
    {
        public UserMap()
        {
            this.ToTable("User");

            this.HasKey(u => u.Id);

            this.Property(u => u.MembershipName).IsRequired().HasMaxLength(256);
            this.Property(u => u.MembershipEmail).IsRequired().HasMaxLength(256);
            this.Property(u => u.MembershipDate).IsRequired();

            this.Property(u => u.DisplayName).IsRequired().HasMaxLength(100);
            this.Property(u => u.ProfileName).IsRequired().HasMaxLength(100);
            this.Property(u => u.Deleted).IsRequired();

            this.Property(u => u.CreatedByUserId).IsRequired();
            this.Property(u => u.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(u => u.CreatedOnDate).IsRequired();
            this.Property(u => u.ModifiedByUserId).IsRequired();
            this.Property(u => u.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(u => u.ModifiedOnDate).IsRequired();

            this.Ignore(u => u.IsSuperAdmin);
            this.Ignore(u => u.IsAdmin);
        }
    }
}