﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class WidgetDefinitionMap : EntityTypeConfiguration<WidgetDefinition>
    {
        public WidgetDefinitionMap()
        {
            this.ToTable("WidgetDefinition");

            this.HasKey(wd => wd.Id);

            this.Property(wd => wd.AppId).IsRequired();
            this.Property(wd => wd.Name).IsRequired().HasMaxLength(100);
            this.Property(wd => wd.Description).HasMaxLength(2000);
            this.Property(wd => wd.Title).HasMaxLength(100);
            this.Property(wd => wd.Controller).IsRequired().HasMaxLength(100);
            this.Property(wd => wd.Action).IsRequired().HasMaxLength(100);
            this.Property(wd => wd.AdminController).HasMaxLength(100);
            this.Property(wd => wd.AdminAction).HasMaxLength(100);
            this.Property(wd => wd.TypeId).IsRequired();
            this.Property(wd => wd.Icon).HasMaxLength(100);
            this.Property(wd => wd.Deleted).IsRequired();
            this.Property(wd => wd.CreatedByUserId).IsRequired();
            this.Property(wd => wd.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(wd => wd.CreatedOnDate).IsRequired();
            this.Property(wd => wd.ModifiedByUserId).IsRequired();
            this.Property(wd => wd.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(wd => wd.ModifiedOnDate).IsRequired();
        }
    }
}