﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using Weapsy.Entities;

namespace Weapsy.Data.Mapping
{
    public partial class WidgetMap : EntityTypeConfiguration<Widget>
    {
        public WidgetMap()
        {
            this.ToTable("Widget");

            this.HasKey(w => w.Id);

            this.Property(w => w.SiteId).IsRequired();
            this.Property(w => w.WidgetDefinitionId).IsRequired();
            this.Property(w => w.Title).HasMaxLength(100);
            this.Property(w => w.Authorized).IsRequired().HasMaxLength(1000);
            this.Property(w => w.Active).IsRequired();
            this.Property(w => w.SortOrder).IsRequired();
            this.Property(w => w.Deleted).IsRequired();
            this.Property(w => w.CreatedByUserId).IsRequired();
            this.Property(w => w.CreatedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(w => w.CreatedOnDate).IsRequired();
            this.Property(w => w.ModifiedByUserId).IsRequired();
            this.Property(w => w.ModifiedByIpAddress).IsRequired().HasMaxLength(15);
            this.Property(w => w.ModifiedOnDate).IsRequired();

            this.HasRequired(w => w.Site)
                .WithMany(s => s.Widgets)
                .HasForeignKey(w => w.SiteId);

            this.HasRequired(w => w.WidgetDefinition)
                .WithMany(wd => wd.Widgets)
                .HasForeignKey(w => w.WidgetDefinitionId);

            this.Ignore(w => w.LocalizedTitle);
        }
    }
}