namespace Weapsy.Data.Migrations
{
    using System.Data.Entity.Migrations;
    
    public partial class InitialCreate : DbMigration
    {
        public override void Up()
        {
            CreateTable(
                "App",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        Title = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 2000),
                        Folder = c.String(nullable: false, maxLength: 100),
                        Url = c.String(nullable: false, maxLength: 100),
                        AdminController = c.String(nullable: false, maxLength: 100),
                        AdminAction = c.String(nullable: false, maxLength: 100),
                        DashboardIcon = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "EmailAccount",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        Address = c.String(nullable: false, maxLength: 250),
                        DisplayName = c.String(maxLength: 100),
                        Host = c.String(nullable: false, maxLength: 250),
                        Port = c.Int(nullable: false),
                        UserName = c.String(maxLength: 250),
                        Password = c.String(maxLength: 250),
                        DefaultCredentials = c.Boolean(nullable: false),
                        Ssl = c.Boolean(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "Language",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        CultureName = c.String(nullable: false, maxLength: 50),
                        CultureNativeName = c.String(nullable: false, maxLength: 200),
                        CultureEnglishName = c.String(nullable: false, maxLength: 200),
                        Url = c.String(nullable: false, maxLength: 50),
                        Flag = c.String(maxLength: 100),
                        Active = c.Boolean(nullable: false),
                        SortOrder = c.Int(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Site", t => t.SiteId)
                .Index(t => t.SiteId);
            
            CreateTable(
                "Site",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        LanguageId = c.Int(nullable: false),
                        LanguageSelectionEnabled = c.Boolean(nullable: false),
                        LanguageUrlEnabled = c.Boolean(nullable: false),
                        ThemeId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                        MetaTitle = c.String(maxLength: 250),
                        MetaDescription = c.String(maxLength: 500),
                        MetaKeywords = c.String(maxLength: 500),
                        Closed = c.Boolean(nullable: false),
                        PageTemplateId = c.Int(nullable: false),
                        ModuleTemplateId = c.Int(nullable: false),
                        HomePageId = c.Int(nullable: false),
                        Copyright = c.String(nullable: false, maxLength: 250),
                        Logo = c.String(maxLength: 100),
                        Url = c.String(maxLength: 250),
                        Deleted = c.Boolean(nullable: false),
                        RegisterMailTemplateId = c.Int(nullable: false),
                        RegisterEmailAccountId = c.Int(nullable: false),
                        PasswordRecoveryMailTemplateId = c.Int(nullable: false),
                        PasswordRecoveryEmailAccountId = c.Int(nullable: false),
                        ChangePasswordMailTemplateId = c.Int(nullable: false),
                        ChangePasswordEmailAccountId = c.Int(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "LocalizedSite",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                        MetaTitle = c.String(maxLength: 250),
                        MetaDescription = c.String(maxLength: 500),
                        MetaKeywords = c.String(maxLength: 500),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("Site", t => t.SiteId)
                .Index(t => t.LanguageId)
                .Index(t => t.SiteId);
            
            CreateTable(
                "Page",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        ParentId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Url = c.String(maxLength: 200),
                        PageTitle = c.String(maxLength: 100),
                        PageIcon = c.String(maxLength: 256),
                        PageImage = c.String(maxLength: 256),
                        MenuText = c.String(maxLength: 100),
                        MenuTitle = c.String(maxLength: 250),
                        MenuIcon = c.String(maxLength: 256),
                        MenuImage = c.String(maxLength: 256),
                        MetaTitle = c.String(maxLength: 250),
                        MetaDescription = c.String(maxLength: 500),
                        MetaKeywords = c.String(maxLength: 500),
                        PageTemplateId = c.Int(nullable: false),
                        ModuleTemplateId = c.Int(nullable: false),
                        Authorized = c.String(nullable: false, maxLength: 1000),
                        MainMenu = c.Boolean(nullable: false),
                        SortOrder = c.Int(nullable: false),
                        Active = c.Boolean(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        StartDate = c.DateTime(),
                        EndDate = c.DateTime(),
                        DisplayPageTitle = c.Boolean(nullable: false),
                        LanguageUrlEnabled = c.Boolean(nullable: false),
                        SiteMap = c.Boolean(nullable: false),
                        Link = c.String(maxLength: 256),
                        Disabled = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Site", t => t.SiteId)
                .Index(t => t.SiteId);
            
            CreateTable(
                "LocalizedPage",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        PageId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Url = c.String(maxLength: 200),
                        PageTitle = c.String(maxLength: 100),
                        PageImage = c.String(maxLength: 256),
                        MenuText = c.String(maxLength: 100),
                        MenuTitle = c.String(maxLength: 250),
                        MenuImage = c.String(maxLength: 256),
                        MetaTitle = c.String(maxLength: 250),
                        MetaDescription = c.String(maxLength: 500),
                        MetaKeywords = c.String(maxLength: 500),
                        Body = c.String(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("Page", t => t.PageId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.PageId);
            
            CreateTable(
                "PageModule",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        PageId = c.Int(nullable: false),
                        ModuleId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                        Zone = c.String(nullable: false, maxLength: 100),
                        ModuleTemplateId = c.Int(nullable: false),
                        SortOrder = c.Int(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        Icon = c.String(maxLength: 100),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Module", t => t.ModuleId, cascadeDelete: true)
                .ForeignKey("Page", t => t.PageId, cascadeDelete: true)
                .Index(t => t.ModuleId)
                .Index(t => t.PageId);
            
            CreateTable(
                "Module",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        ModuleDefinitionId = c.Int(nullable: false),
                        Title = c.String(nullable: false, maxLength: 100),
                        AllPages = c.Boolean(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        InheritPermissions = c.Boolean(nullable: false),
                        Authorized = c.String(nullable: false, maxLength: 1000),
                        StartDate = c.DateTime(),
                        EndDate = c.DateTime(),
                        DisplayTitle = c.Boolean(nullable: false),
                        Zone = c.String(nullable: false, maxLength: 100),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Site", t => t.SiteId, cascadeDelete: true)
                .ForeignKey("ModuleDefinition", t => t.ModuleDefinitionId, cascadeDelete: true)
                .Index(t => t.SiteId)
                .Index(t => t.ModuleDefinitionId);
            
            CreateTable(
                "ModuleDefinition",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        AppId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Title = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 2000),
                        Controller = c.String(nullable: false, maxLength: 100),
                        Action = c.String(nullable: false, maxLength: 100),
                        AdminController = c.String(maxLength: 100),
                        AdminAction = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "LocalizedModule",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        ModuleId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("Module", t => t.ModuleId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.ModuleId);
            
            CreateTable(
                "Text",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        ModuleId = c.Int(nullable: false),
                        TextVersionId = c.Int(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Module", t => t.ModuleId, cascadeDelete: true)
                .Index(t => t.ModuleId);
            
            CreateTable(
                "TextVersion",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        TextId = c.Int(nullable: false),
                        Description = c.String(maxLength: 250),
                        Body = c.String(),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Text", t => t.TextId, cascadeDelete: true)
                .Index(t => t.TextId);
            
            CreateTable(
                "LocalizedTextVersion",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        TextVersionId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Body = c.String(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("TextVersion", t => t.TextVersionId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.TextVersionId);
            
            CreateTable(
                "LocalizedPageModule",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        PageModuleId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("PageModule", t => t.PageModuleId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.PageModuleId);
            
            CreateTable(
                "MailTemplate",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        MailTemplateTypeId = c.Int(nullable: false),
                        SiteId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 250),
                        Subject = c.String(nullable: false, maxLength: 250),
                        BodyHtml = c.String(nullable: false),
                        BodyPlain = c.String(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("MailTemplateType", t => t.MailTemplateTypeId, cascadeDelete: true)
                .ForeignKey("Site", t => t.SiteId, cascadeDelete: true)
                .Index(t => t.MailTemplateTypeId)
                .Index(t => t.SiteId);
            
            CreateTable(
                "MailTemplateType",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        AppId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 250),
                        TokenController = c.String(maxLength: 100),
                        TokenAction = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "LocalizedMailTemplate",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        MailTemplateId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Subject = c.String(maxLength: 250),
                        BodyHtml = c.String(),
                        BodyPlain = c.String(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("MailTemplate", t => t.MailTemplateId, cascadeDelete: true)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .Index(t => t.MailTemplateId)
                .Index(t => t.LanguageId);
            
            CreateTable(
                "Plugin",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        PluginDefinitionId = c.Int(nullable: false),
                        DashboardText = c.String(maxLength: 100),
                        DashboardTitle = c.String(maxLength: 250),
                        MenuText = c.String(maxLength: 100),
                        MenuTitle = c.String(maxLength: 250),
                        SortOrder = c.Int(nullable: false),
                        Active = c.Boolean(nullable: false),
                        Authorized = c.String(nullable: false, maxLength: 1000),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Site", t => t.SiteId, cascadeDelete: true)
                .ForeignKey("PluginDefinition", t => t.PluginDefinitionId, cascadeDelete: true)
                .Index(t => t.SiteId)
                .Index(t => t.PluginDefinitionId);
            
            CreateTable(
                "PluginDefinition",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        AppId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 2000),
                        DashboardText = c.String(maxLength: 100),
                        DashboardTitle = c.String(maxLength: 250),
                        MenuText = c.String(maxLength: 100),
                        MenuTitle = c.String(maxLength: 250),
                        Controller = c.String(nullable: false, maxLength: 100),
                        Action = c.String(nullable: false, maxLength: 100),
                        AdminController = c.String(maxLength: 100),
                        AdminAction = c.String(maxLength: 100),
                        TypeId = c.Byte(nullable: false),
                        DashboardIcon = c.String(maxLength: 100),
                        MenuIcon = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "LocalizedPlugin",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        PluginId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        DashboardText = c.String(maxLength: 100),
                        DashboardTitle = c.String(maxLength: 250),
                        MenuText = c.String(maxLength: 100),
                        MenuTitle = c.String(maxLength: 250),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("Plugin", t => t.PluginId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.PluginId);
            
            CreateTable(
                "Widget",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        SiteId = c.Int(nullable: false),
                        WidgetDefinitionId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                        SortOrder = c.Int(nullable: false),
                        Active = c.Boolean(nullable: false),
                        Authorized = c.String(nullable: false, maxLength: 1000),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Site", t => t.SiteId, cascadeDelete: true)
                .ForeignKey("WidgetDefinition", t => t.WidgetDefinitionId, cascadeDelete: true)
                .Index(t => t.SiteId)
                .Index(t => t.WidgetDefinitionId);
            
            CreateTable(
                "WidgetDefinition",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        AppId = c.Int(nullable: false),
                        Name = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 2000),
                        Title = c.String(maxLength: 100),
                        Controller = c.String(nullable: false, maxLength: 100),
                        Action = c.String(nullable: false, maxLength: 100),
                        AdminController = c.String(maxLength: 100),
                        AdminAction = c.String(maxLength: 100),
                        TypeId = c.Byte(nullable: false),
                        Icon = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "LocalizedWidget",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        WidgetId = c.Int(nullable: false),
                        LanguageId = c.Int(nullable: false),
                        Title = c.String(maxLength: 100),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("Language", t => t.LanguageId, cascadeDelete: true)
                .ForeignKey("Widget", t => t.WidgetId, cascadeDelete: true)
                .Index(t => t.LanguageId)
                .Index(t => t.WidgetId);
            
            CreateTable(
                "ModuleTemplate",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        ViewName = c.String(nullable: false, maxLength: 100),
                        PreviewImage = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "PageTemplate",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        Zones = c.String(nullable: false, maxLength: 250),
                        ViewName = c.String(nullable: false, maxLength: 100),
                        PreviewImage = c.String(maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "Setting",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        Value = c.String(maxLength: 1000),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "Theme",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 100),
                        Description = c.String(maxLength: 250),
                        Folder = c.String(nullable: false, maxLength: 100),
                        PreviewImage = c.String(maxLength: 100),
                        SortOrder = c.Int(nullable: false),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "User",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        MembershipName = c.String(nullable: false, maxLength: 256),
                        MembershipEmail = c.String(nullable: false, maxLength: 256),
                        MembershipDate = c.DateTime(nullable: false),
                        DisplayName = c.String(nullable: false, maxLength: 100),
                        ProfileName = c.String(nullable: false, maxLength: 100),
                        Deleted = c.Boolean(nullable: false),
                        CreatedByUserId = c.Int(nullable: false),
                        CreatedByIpAddress = c.String(nullable: false, maxLength: 15),
                        CreatedOnDate = c.DateTime(nullable: false),
                        ModifiedByUserId = c.Int(nullable: false),
                        ModifiedByIpAddress = c.String(nullable: false, maxLength: 15),
                        ModifiedOnDate = c.DateTime(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
        }
        
        public override void Down()
        {
            DropIndex("LocalizedWidget", new[] { "WidgetId" });
            DropIndex("LocalizedWidget", new[] { "LanguageId" });
            DropIndex("Widget", new[] { "WidgetDefinitionId" });
            DropIndex("Widget", new[] { "SiteId" });
            DropIndex("LocalizedPlugin", new[] { "PluginId" });
            DropIndex("LocalizedPlugin", new[] { "LanguageId" });
            DropIndex("Plugin", new[] { "PluginDefinitionId" });
            DropIndex("Plugin", new[] { "SiteId" });
            DropIndex("LocalizedMailTemplate", new[] { "LanguageId" });
            DropIndex("LocalizedMailTemplate", new[] { "MailTemplateId" });
            DropIndex("MailTemplate", new[] { "SiteId" });
            DropIndex("MailTemplate", new[] { "MailTemplateTypeId" });
            DropIndex("LocalizedPageModule", new[] { "PageModuleId" });
            DropIndex("LocalizedPageModule", new[] { "LanguageId" });
            DropIndex("LocalizedTextVersion", new[] { "TextVersionId" });
            DropIndex("LocalizedTextVersion", new[] { "LanguageId" });
            DropIndex("TextVersion", new[] { "TextId" });
            DropIndex("Text", new[] { "ModuleId" });
            DropIndex("LocalizedModule", new[] { "ModuleId" });
            DropIndex("LocalizedModule", new[] { "LanguageId" });
            DropIndex("Module", new[] { "ModuleDefinitionId" });
            DropIndex("Module", new[] { "SiteId" });
            DropIndex("PageModule", new[] { "PageId" });
            DropIndex("PageModule", new[] { "ModuleId" });
            DropIndex("LocalizedPage", new[] { "PageId" });
            DropIndex("LocalizedPage", new[] { "LanguageId" });
            DropIndex("Page", new[] { "SiteId" });
            DropIndex("LocalizedSite", new[] { "SiteId" });
            DropIndex("LocalizedSite", new[] { "LanguageId" });
            DropIndex("Language", new[] { "SiteId" });
            DropForeignKey("LocalizedWidget", "WidgetId", "Widget");
            DropForeignKey("LocalizedWidget", "LanguageId", "Language");
            DropForeignKey("Widget", "WidgetDefinitionId", "WidgetDefinition");
            DropForeignKey("Widget", "SiteId", "Site");
            DropForeignKey("LocalizedPlugin", "PluginId", "Plugin");
            DropForeignKey("LocalizedPlugin", "LanguageId", "Language");
            DropForeignKey("Plugin", "PluginDefinitionId", "PluginDefinition");
            DropForeignKey("Plugin", "SiteId", "Site");
            DropForeignKey("LocalizedMailTemplate", "LanguageId", "Language");
            DropForeignKey("LocalizedMailTemplate", "MailTemplateId", "MailTemplate");
            DropForeignKey("MailTemplate", "SiteId", "Site");
            DropForeignKey("MailTemplate", "MailTemplateTypeId", "MailTemplateType");
            DropForeignKey("LocalizedPageModule", "PageModuleId", "PageModule");
            DropForeignKey("LocalizedPageModule", "LanguageId", "Language");
            DropForeignKey("LocalizedTextVersion", "TextVersionId", "TextVersion");
            DropForeignKey("LocalizedTextVersion", "LanguageId", "Language");
            DropForeignKey("TextVersion", "TextId", "Text");
            DropForeignKey("Text", "ModuleId", "Module");
            DropForeignKey("LocalizedModule", "ModuleId", "Module");
            DropForeignKey("LocalizedModule", "LanguageId", "Language");
            DropForeignKey("Module", "ModuleDefinitionId", "ModuleDefinition");
            DropForeignKey("Module", "SiteId", "Site");
            DropForeignKey("PageModule", "PageId", "Page");
            DropForeignKey("PageModule", "ModuleId", "Module");
            DropForeignKey("LocalizedPage", "PageId", "Page");
            DropForeignKey("LocalizedPage", "LanguageId", "Language");
            DropForeignKey("Page", "SiteId", "Site");
            DropForeignKey("LocalizedSite", "SiteId", "Site");
            DropForeignKey("LocalizedSite", "LanguageId", "Language");
            DropForeignKey("Language", "SiteId", "Site");
            DropTable("User");
            DropTable("Theme");
            DropTable("Setting");
            DropTable("PageTemplate");
            DropTable("ModuleTemplate");
            DropTable("LocalizedWidget");
            DropTable("WidgetDefinition");
            DropTable("Widget");
            DropTable("LocalizedPlugin");
            DropTable("PluginDefinition");
            DropTable("Plugin");
            DropTable("LocalizedMailTemplate");
            DropTable("MailTemplateType");
            DropTable("MailTemplate");
            DropTable("LocalizedPageModule");
            DropTable("LocalizedTextVersion");
            DropTable("TextVersion");
            DropTable("Text");
            DropTable("LocalizedModule");
            DropTable("ModuleDefinition");
            DropTable("Module");
            DropTable("PageModule");
            DropTable("LocalizedPage");
            DropTable("Page");
            DropTable("LocalizedSite");
            DropTable("Site");
            DropTable("Language");
            DropTable("EmailAccount");
            DropTable("App");
        }
    }
}
