#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Entities;

namespace Weapsy.Apps.Forum.Entities
{
    public partial class ForumConfiguration : BaseAuditEntity
    {
        public ForumConfiguration()
        {
            this.Categories = new HashSet<ForumCategory>();
            this.PermissionSets = new HashSet<ForumPermissionSet>();
            this.SettingSets = new HashSet<ForumSettingSet>();
        }

        public int SiteId { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public bool Enabled { get; set; }
        public int PermissionSetId { get; set; }
        public int SettingSetId { get; set; }

        public virtual Site Site { get; set; }
        public virtual ICollection<ForumCategory> Categories { get; set; }
        public virtual ICollection<ForumPermissionSet> PermissionSets { get; set; }
        public virtual ICollection<ForumSettingSet> SettingSets { get; set; }
    }
}
