#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Entities;

namespace Weapsy.Apps.Forum.Entities
{
    public partial class ForumPost : BaseAuditEntity
    {
        public ForumPost()
        {
            this.Posts = new HashSet<ForumPost>();
        }

        public int SectionId { get; set; }
        public int ParentId { get; set; }
        public string Title { get; set; }
        public string Url { get; set; }
        public string Body { get; set; }
        public string IconImage { get; set; }
        public bool Pinned { get; set; }
        public bool Locked { get; set; }
        public Nullable<int> LastReplyId { get; set; }
        public int Replies { get; set; }
        public int Views { get; set; }
        public bool Moved { get; set; }
        public Nullable<int> MovedFromSectionId { get; set; }
        public Nullable<int> MovedByUserId { get; set; }
        public string MovedByIpAddress { get; set; }
        public Nullable<DateTime> MovedOnDate { get; set; }
        public bool Deleted { get; set; }
        public Nullable<int> DeletedByUserId { get; set; }
        public string DeletedByIpAddress { get; set; }
        public Nullable<DateTime> DeletedOnDate { get; set; }

        public virtual ForumSection Section { get; set; }
        public virtual ForumPost Parent { get; set; }
        public virtual ICollection<ForumPost> Posts { get; set; }
        public virtual ForumUser CreatedByUser { get; set; }
        public virtual ForumUser ModifiedByUser { get; set; }
    }
}
