#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;

namespace Weapsy.Entities
{
    public partial class Page : BaseAuditEntity
    {
        public Page()
        {
            this.LocalizedPages = new HashSet<LocalizedPage>();
            this.PageModules = new HashSet<PageModule>();
        }
    
        public int SiteId { get; set; }
        public int ParentId { get; set; }
        public string Name { get; set; }
        public string Url { get; set; }
        public string PageTitle { get; set; }
        public string PageIcon { get; set; }
        public string PageImage { get; set; }
        public string MenuText { get; set; }
        public string MenuTitle { get; set; }
        public string MenuIcon { get; set; }
        public string MenuImage { get; set; }
        public string MetaTitle { get; set; }
        public string MetaDescription { get; set; }
        public string MetaKeywords { get; set; }
        public int PageTemplateId { get; set; }
        public int ModuleTemplateId { get; set; }
        public string Authorized { get; set; }
        public bool MainMenu { get; set; }
        public int SortOrder { get; set; }
        public bool Active { get; set; }
        public bool Deleted { get; set; }
        public Nullable<DateTime> StartDate { get; set; }
        public Nullable<DateTime> EndDate { get; set; }
        public bool DisplayPageTitle { get; set; }
        public bool LanguageUrlEnabled { get; set; }
        public bool SiteMap { get; set; }
        public string Link { get; set; }
        public bool Disabled { get; set; }

        //public string Body { get; set; }
        //public bool UseModules { get; set; }

        public Site Site { get; set; }
        //public ModuleTemplate ModuleTemplate { get; set; }
        //public PageTemplate PageTemplate { get; set; }

        public virtual ICollection<LocalizedPage> LocalizedPages { get; set; }
        public virtual ICollection<PageModule> PageModules { get; set; }

        public int PageModuleCount { get; set; }

        public string LocalizedUrl { get; set; }
        public string LocalizedPageTitle { get; set; }
        public string LocalizedPageImage { get; set; }
        public string LocalizedMenuText { get; set; }
        public string LocalizedMenuTitle { get; set; }
        public string LocalizedMenuImage { get; set; }
        public string LocalizedMetaTitle { get; set; }
        public string LocalizedMetaDescription { get; set; }
        public string LocalizedMetaKeywords { get; set; }

        public string NameForTree { get; set; }
    }
}