#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface ILanguageService
    {

        Language Create(Language entity);

        void Update(Language entity);

        void Delete(Language entity);

        Language GetById(int SiteId, int Id);
        Language GetById(int SiteId, int Id, bool UseCache);

        Language GetByName(int SiteId, string Name);
        Language GetByName(int SiteId, string Name, bool UseCache);

        Language GetByCultureName(int SiteId, string CultureName);
        Language GetByCultureName(int SiteId, string CultureName, bool UseCache);

        Language GetByUrl(int SiteId, string Url);
        Language GetByUrl(int SiteId, string Url, bool UseCache);

        List<Language> GetList(int SiteId);
        List<Language> GetList(int SiteId, bool UseCache);

        Dictionary<string, string> GetDictionary(int SiteId);

        void Move(int SiteId, int Id, string Action);

	}

}