#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface IModuleService
    {

        void Create(Module entity,
            List<LocalizedModule> localizedEntities);

        void CreateForPage(PageModule entity,
            List<LocalizedPageModule> localizedEntities);

        void CreateLocalized(LocalizedModule entity);

        void CreateLocalizedForPage(LocalizedPageModule entity);

        void AddNew(Module module,
            List<LocalizedModule> localizedModules,
            PageModule pageModule,
            List<LocalizedPageModule> localizedPageModules);

        void AddExisting(PageModule pageModule,
            List<LocalizedPageModule> localizedPageModules);

        void Update(Module entity,
            List<LocalizedModule> localizedEntities);

        void Update(PageModule entity,
            List<LocalizedPageModule> localizedEntities);

        void Delete(Module entity);

        void DeleteForPage(PageModule entity);

        Module GetById(int SiteId, int Id);

        PageModule GetForPageById(int siteId, int id);

        LocalizedModule GetLocalizedById(int Id);

        LocalizedModule GetLocalizedByModuleId(int moduleId, int languageId);

        LocalizedPageModule GetLocalizedForPageByPageModuleId(int pageModuleId, int languageId);

        LocalizedPageModule GetLocalizedForPageById(int Id);

        List<Module> GetList(int siteId);

        List<Module> GetListForAllPages(int siteId);

        List<PageModule> GetListForModule(int moduleId);

        List<PageModule> GetListForPage(int siteId, int pageId);

        List<LocalizedPageModule> GetLocalizedListForPage(int pageModuleId);

        List<Module> GetListForExisting(int SiteId, int ExcludePageId);

        List<PageModule> GetPageModules(int SiteId, int PageId, int LanguageId);

	}

}