#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface IPageService
    {

        void Create(Page entity, List<LocalizedPage> localizedEntities);

        LocalizedPage CreateLocalized(LocalizedPage entity);

        void Update(Page entity, List<LocalizedPage> localizedEntities);

        void Delete(Page entity);

        Page GetById(int SiteId, int PageId);

        Page GetByName(int SiteId, string Name);

        Page GetByUrl(int SiteId, string Url);

        LocalizedPage GetLocalizedByPageId(int PageId, int LanguageId);

        LocalizedPage GetLocalizedById(int id);

        List<Page> GetList(int SiteId);

        List<Page> GetSitePages(int SiteId, int LanguageId);

        List<Page> GetSitePagesForTree(int SiteId, int LanguageId);

        Dictionary<string, string> GetDictionary(int SiteId, int LanguageId);

        Dictionary<string, string> GetDictionaryForParent(int SiteId, int LanguageId, int ExcludePageId);

        void Move(int SiteId, int Id, string Action);

	}

}