#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface IPluginService
    {

        void Create(Plugin entity, List<LocalizedPlugin> localizedEntities);

        LocalizedPlugin CreateLocalized(LocalizedPlugin entity);

        void Update(Plugin entity, List<LocalizedPlugin> localizedEntities);

        void Delete(Plugin entity);

        Plugin GetById(int SiteId, int Id);

        LocalizedPlugin GetLocalizedByPluginId(int PluginId, int LanguageId);

        LocalizedPlugin GetLocalizedById(int Id);

        List<Plugin> GetList(int siteId);

        List<Plugin> GetList(int SiteId, PluginType pluginType);

        List<LocalizedPlugin> GetLocalizedList(int pluginId);

        List<Plugin> GetSitePlugins(int SiteId, PluginType pluginType, int LanguageId);

        void Move(int SiteId, int Id, string Action);

	}

}