#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface ISettingService
    {

        Setting Create(Setting entity);

        void Update(Setting entity);

        void Save<T>(T settings) where T : ISettings;

        void Set<T>(string name, T value);

        void Delete(Setting entity);

        Setting GetById(int Id);
        Setting GetById(int Id, bool UseCache);

        Setting GetByName(string Name);
        Setting GetByName(string Name, bool UseCache);

        List<Setting> GetList();
        List<Setting> GetList(bool UseCache);

        T GetSettings<T>() where T : ISettings;
	}

}