#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface ISiteService
    {

        void Create(Site entity);

        void CreateLocalized(LocalizedSite entity);

        void Update(Site entity, List<LocalizedSite> localizedEntities);

        void Delete(Site entity);

        Site GetById(int Id);

        Site Get();
        Site Get(bool UseCache);

        Site GetByName(string Name);
        Site GetByName(string Name, bool UseCache);

        LocalizedSite GetLocalizedBySiteId(int siteId, int languageId);
        LocalizedSite GetLocalizedBySiteId(int siteId, int languageId, bool UseCache);

        LocalizedSite GetLocalizedById(int id);

        List<Site> GetList();

	}

}