#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface ITextService
    {

        void Create(Text text,
            TextVersion textVersion,
            List<LocalizedTextVersion> localizedTextVersions);

        TextVersion CreateVersion(TextVersion textVersion,
            List<LocalizedTextVersion> localizedTextVersions, 
            int moduleId);

        LocalizedTextVersion CreateLocalizedVersion(LocalizedTextVersion entity);

        void Update(Text entity);

        void UpdateVersion(TextVersion entity,
            List<LocalizedTextVersion> localizedEntities);

        void Delete(Text entity);

        void Delete(TextVersion entity);

        Text GetById(int Id);

        Text GetByModuleId(int siteId, int moduleId);

        TextVersion GetVersionById(int id);

        LocalizedTextVersion GetLocalizedVersionByVersionId(int versionId, int languageId);

        LocalizedTextVersion GetLocalizedVersionById(int id);

        string GetText(int SiteId, int ModuleId, int LanguageId);

        List<Text> GetList(int siteId);

        List<TextVersion> GetVersionList(int textId);

	}

}