#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Entities;

namespace Weapsy.Services
{

	public interface IWidgetService
    {

        void Create(Widget entity, List<LocalizedWidget> localizedEntities);

        LocalizedWidget CreateLocalized(LocalizedWidget entity);

        void Update(Widget entity, List<LocalizedWidget> localizedEntities);

        void Delete(Widget entity);

        Widget GetById(int SiteId, int Id);

        LocalizedWidget GetLocalizedByWidgetId(int WidgetId, int LanguageId);

        LocalizedWidget GetLocalizedById(int Id);

        List<Widget> GetList(int siteId);

        List<Widget> GetList(int SiteId, WidgetType widgetType);

        List<LocalizedWidget> GetLocalizedList(int widgetId);

        List<Widget> GetSiteWidgets(int SiteId, WidgetType widgetType, int LanguageId);

        void Move(int SiteId, int Id, string Action);

	}

}