#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Text;
using System.Collections.Generic;
using System.Web.Configuration;
using Weapsy;

namespace Weapsy.Services
{

	public class RoleService : IRoleService
	{
        public string GetDefaultRoles(bool includeAll, bool includeRegistered, bool includeAnonymous)
        {
            string result = "";

            if (includeAll) { result += Consts.RoleAll + ","; }
            if (includeRegistered) { result += Consts.RoleRegistered + ","; }
            if (includeAnonymous) { result += Consts.RoleAnonymous + ","; }

            result += AppSettings.RoleAdmin + "," + AppSettings.RoleSuperAdmin;

            return result;
        }

        public List<string> GetList()
        {
            return GetList(true, true, true);
        }

        public List<string> GetList(bool includeAll, bool includeRegistered, bool includeAnonymous)
        {
            List<string> list = new List<string>();

            if (includeAll) list.Add(Consts.RoleAll);
            if (includeRegistered) list.Add(Consts.RoleRegistered);
            if (includeAnonymous) list.Add(Consts.RoleAnonymous);

            foreach (string x in System.Web.Security.Roles.GetAllRoles())
            {
                list.Add(x);
            }

            return list;
        }

	}

}