﻿using Weapsy.Web.Admin.Controllers;
using System;
using Weapsy.Services;
using System.Web.Mvc;
using Weapsy.Web.Admin.Models;
using Moq;
using Xunit;
using System.Collections.Generic;
using Weapsy.Entities;
using Weapsy.Web.Admin.Extensions.Moles;
using Weapsy.Tests.CustomAttributes;

namespace Weapsy.Tests.Controllers.Admin
{
    public class AppControllerTest
    {
        private Mock<IAppService> mockAppService;
        private Mock<IModuleDefinitionService> mockModuleDefinitionService;
        private Mock<IPluginDefinitionService> mockPluginDefinitionService;
        private Mock<IWidgetDefinitionService> mockWidgetDefinitionService;

        public AppControllerTest()
        {
            mockAppService = new Mock<IAppService>();
            mockModuleDefinitionService = new Mock<IModuleDefinitionService>();
            mockPluginDefinitionService = new Mock<IPluginDefinitionService>();
            mockWidgetDefinitionService = new Mock<IWidgetDefinitionService>();
        }

        //[Fact]
        //public void Create_ReturnsViewWhereModelIsAppModelList()
        //{
        //    AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);

        //    var result = target.Create() as ViewResult;

        //    Assert.IsType(typeof(List<AppModel>), result.ViewData.Model);
        //}

        //[Fact]
        //public void Create_GivenAppModelFromPOST_ReturnsViewWhereModelIsAppModelList()
        //{
        //    AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);

        //    mockAppService.Setup(x => x.GetByName(It.IsAny<string>(), false)).Returns((App)null);

        //    var result = target.Create(new AppModel()) as ViewResult;

        //    Assert.IsType(typeof(List<AppModel>), result.ViewData.Model);
        //}

        //[Fact]
        //public void Delete_GivenAppModel_DeletesAppAndRedirectsToListAction()
        //{
        //    AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
        //    mockAppService.Setup(x => x.GetById(It.IsAny<int>(), false)).Returns(new App());

        //    var result = target.Delete(new AppModel()) as RedirectToRouteResult;

        //    mockAppService.Verify(x => x.Delete(It.IsAny<App>()), Times.Once());
        //    Assert.Equal("List", result.RouteValues["action"]);
        //}

        [Fact]
        [Moled]
        public void Edit_GivenId_ReturnsViewWhereModelIsAppModel()
        {
            AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object,
                mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
            mockAppService.Setup(x => x.GetById(It.IsAny<int>())).Returns(new App());
            MMappingExtensions.ToModelApp = (ent) => { return new AppModel(); };
            int Id = 1;

            var result = target.Edit(Id) as ViewResult;

            Assert.IsType(typeof(AppModel), result.ViewData.Model);
        }

        [Fact]
        public void Index_RedirectsToListAction()
        {
            AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object,
                mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);

            var result = target.Index() as RedirectToRouteResult;

            Assert.Equal("List", result.RouteValues["action"]);
        }

        [Fact]
        [Moled]
        public void List_ReturnsViewWhereModelIsAppModelList()
        {
            AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object,
                mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
            mockAppService.Setup(x => x.GetList()).Returns(Stubs.GetAppListStub());
            MMappingExtensions.ToModelsListOfApp = (lst) => { return Stubs.GetAppModelListStub(); };

            var result = target.List() as ViewResult;

            Assert.IsType(typeof(List<AppModel>), result.ViewData.Model);
        }

        //[Fact]
        //[Moled]
        //public void Update_GivenAppModelFromPOST_RedirectsToEditAction()
        //{
        //    AppController target = new AppController(mockAppService.Object, mockModuleDefinitionService.Object, 
        //        mockPluginDefinitionService.Object, mockWidgetDefinitionService.Object);
        //    mockAppService.Setup(x => x.GetById(It.IsAny<int>(), false)).Returns(new App());
        //    MMappingExtensions.ToModelApp = (ent) => { return new AppModel(); };

        //    var result = target.Update(Stubs.GetFakeAppModel()) as RedirectToRouteResult;

        //    Assert.Equal("List", result.RouteValues["action"]);
        //}
    }
}
