#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using Weapsy.Core.Caching;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Entities;
using Weapsy.Services;
using Weapsy.Web.Admin.Extensions;
using Weapsy.Web.Admin.Models;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Controllers;
using AutoMapper;

namespace Weapsy.Web.Admin.Controllers
{

    [Authorize(Roles="SuperAdmin")]
	public class HomeController : BaseAdminController
    {

        #region Private Members

        private readonly IAppService _appService;
        private readonly ICacheManager _cacheManager;

        #endregion

        #region Constructors

        public HomeController(IAppService appService, ICacheManager cacheManager)
        {
            _appService = appService;
            _cacheManager = cacheManager;
        }

        #endregion

        #region Public Methods

        public ActionResult Index()
        {
            return View(_appService.GetList().ToModels());
        }

        public ActionResult RestartApplication()
        {
            Utils.RestartApplication();
            return RedirectToAction("Index");
        }

        public ActionResult ClearCache()
        {
            _cacheManager.Clear();
            return RedirectToAction("Index");
        }

        #endregion

    }

}