#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using Weapsy.Core;
using Weapsy.Data;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Entities;
using Weapsy.Services;
using Weapsy.Web.Admin.Extensions;
using Weapsy.Web.Admin.Models;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Controllers;
using AutoMapper;

namespace Weapsy.Web.Admin.Controllers
{

    [Authorize(Roles="SuperAdmin")]
	public class SystemController : BaseAdminController
    {

        #region Private Members



        #endregion

        #region Constructors

        public SystemController()
        {
        }

        #endregion

        #region Public Methods

        public ActionResult Info()
        {
            SystemInfoModel model = new SystemInfoModel();

            model.WeapsyVersion = Consts.Version;
            model.DotNetVersion = RuntimeEnvironment.GetSystemVersion();
            model.FullTrust = AppDomain.CurrentDomain.IsFullyTrusted;
            model.OperatingSystem = Environment.OSVersion.VersionString;

            return View(model);
        }

        #endregion

    }

}