#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Entities;
using Weapsy.Web.Admin.Models;
using AutoMapper;

namespace Weapsy.Web.Admin.Extensions
{

	public static class MappingExtensions
    {

        #region App

        public static App ToEntity(this AppModel model)
        {
            return Mapper.Map<AppModel, App>(model);
        }

        public static App ToEntity(this AppModel model, App entity)
        {
            return Mapper.Map<AppModel, App>(model, entity);
        }

        public static AppModel ToModel(this App entity)
        {
            return Mapper.Map<App, AppModel>(entity);
        }

        public static List<App> ToEntities(this List<AppModel> models)
        {
            return Mapper.Map<List<AppModel>, List<App>>(models);
        }

        public static List<AppModel> ToModels(this List<App> entities)
        {
            return Mapper.Map<List<App>, List<AppModel>>(entities);
        }

        #endregion

        //#region CacheSettings

        //public static CacheSettings ToEntity(this CacheSettingsModel model)
        //{
        //    return Mapper.Map<CacheSettingsModel, CacheSettings>(model);
        //}

        //public static CacheSettings ToEntity(this CacheSettingsModel model, CacheSettings entity)
        //{
        //    return Mapper.Map<CacheSettingsModel, CacheSettings>(model, entity);
        //}

        //public static CacheSettingsModel ToModel(this CacheSettings entity)
        //{
        //    return Mapper.Map<CacheSettings, CacheSettingsModel>(entity);
        //}

        //#endregion

        #region EmailAccount

        public static EmailAccount ToEntity(this EmailAccountModel model)
        {
            return Mapper.Map<EmailAccountModel, EmailAccount>(model);
        }

        public static EmailAccount ToEntity(this EmailAccountModel model, EmailAccount entity)
        {
            return Mapper.Map<EmailAccountModel, EmailAccount>(model, entity);
        }

        public static EmailAccountModel ToModel(this EmailAccount entity)
        {
            return Mapper.Map<EmailAccount, EmailAccountModel>(entity);
        }

        public static List<EmailAccount> ToEntities(this List<EmailAccountModel> models)
        {
            return Mapper.Map<List<EmailAccountModel>, List<EmailAccount>>(models);
        }

        public static List<EmailAccountModel> ToModels(this List<EmailAccount> entities)
        {
            return Mapper.Map<List<EmailAccount>, List<EmailAccountModel>>(entities);
        }

        #endregion

        #region Group

        public static Group ToEntity(this GroupModel model)
        {
            return Mapper.Map<GroupModel, Group>(model);
        }

        public static GroupModel ToModel(this Group entity)
        {
            return Mapper.Map<Group, GroupModel>(entity);
        }

        public static List<Group> ToEntities(this List<GroupModel> models)
        {
            return Mapper.Map<List<GroupModel>, List<Group>>(models);
        }

        public static List<GroupModel> ToModels(this List<Group> entities)
        {
            return Mapper.Map<List<Group>, List<GroupModel>>(entities);
        }

        #endregion

        #region Language

        public static Language ToEntity(this LanguageModel model)
        {
            return Mapper.Map<LanguageModel, Language>(model);
        }

        public static Language ToEntity(this LanguageModel model, Language entity)
        {
            return Mapper.Map<LanguageModel, Language>(model, entity);
        }

        public static LanguageModel ToModel(this Language entity)
        {
            return Mapper.Map<Language, LanguageModel>(entity);
        }

        public static List<Language> ToEntities(this List<LanguageModel> models)
        {
            return Mapper.Map<List<LanguageModel>, List<Language>>(models);
        }

        public static List<LanguageModel> ToModels(this List<Language> entities)
        {
            return Mapper.Map<List<Language>, List<LanguageModel>>(entities);
        }

        #endregion

        #region LocalizedMailTemplate

        public static LocalizedMailTemplate ToEntity(this LocalizedMailTemplateModel model)
        {
            return Mapper.Map<LocalizedMailTemplateModel, LocalizedMailTemplate>(model);
        }

        public static LocalizedMailTemplate ToEntity(this LocalizedMailTemplateModel model, LocalizedMailTemplate entity)
        {
            return Mapper.Map<LocalizedMailTemplateModel, LocalizedMailTemplate>(model, entity);
        }

        public static LocalizedMailTemplateModel ToModel(this LocalizedMailTemplate entity)
        {
            return Mapper.Map<LocalizedMailTemplate, LocalizedMailTemplateModel>(entity);
        }

        public static List<LocalizedMailTemplate> ToEntities(this List<LocalizedMailTemplateModel> models)
        {
            return Mapper.Map<List<LocalizedMailTemplateModel>, List<LocalizedMailTemplate>>(models);
        }

        public static List<LocalizedMailTemplateModel> ToModels(this List<LocalizedMailTemplate> entities)
        {
            return Mapper.Map<List<LocalizedMailTemplate>, List<LocalizedMailTemplateModel>>(entities);
        }

        #endregion

        #region LocalizedModule

        public static LocalizedModule ToEntity(this LocalizedModuleModel model)
        {
            return Mapper.Map<LocalizedModuleModel, LocalizedModule>(model);
        }

        public static LocalizedModule ToEntity(this LocalizedModuleModel model, LocalizedModule entity)
        {
            return Mapper.Map<LocalizedModuleModel, LocalizedModule>(model, entity);
        }

        public static LocalizedModuleModel ToModel(this LocalizedModule entity)
        {
            return Mapper.Map<LocalizedModule, LocalizedModuleModel>(entity);
        }

        public static List<LocalizedModule> ToEntities(this List<LocalizedModuleModel> models)
        {
            return Mapper.Map<List<LocalizedModuleModel>, List<LocalizedModule>>(models);
        }

        public static List<LocalizedModuleModel> ToModels(this List<LocalizedModule> entities)
        {
            return Mapper.Map<List<LocalizedModule>, List<LocalizedModuleModel>>(entities);
        }

        #endregion

        #region LocalizedPage

        public static LocalizedPage ToEntity(this LocalizedPageModel model)
        {
            return Mapper.Map<LocalizedPageModel, LocalizedPage>(model);
        }

        public static LocalizedPage ToEntity(this LocalizedPageModel model, LocalizedPage entity)
        {
            return Mapper.Map<LocalizedPageModel, LocalizedPage>(model, entity);
        }

        public static LocalizedPageModel ToModel(this LocalizedPage entity)
        {
            return Mapper.Map<LocalizedPage, LocalizedPageModel>(entity);
        }

        public static List<LocalizedPage> ToEntities(this List<LocalizedPageModel> models)
        {
            return Mapper.Map<List<LocalizedPageModel>, List<LocalizedPage>>(models);
        }

        public static List<LocalizedPageModel> ToModels(this List<LocalizedPage> entities)
        {
            return Mapper.Map<List<LocalizedPage>, List<LocalizedPageModel>>(entities);
        }

        #endregion

        #region LocalizedPageModule

        public static LocalizedPageModule ToEntity(this LocalizedPageModuleModel model)
        {
            return Mapper.Map<LocalizedPageModuleModel, LocalizedPageModule>(model);
        }

        public static LocalizedPageModule ToEntity(this LocalizedPageModuleModel model, LocalizedPageModule entity)
        {
            return Mapper.Map<LocalizedPageModuleModel, LocalizedPageModule>(model, entity);
        }

        public static LocalizedPageModuleModel ToModel(this LocalizedPageModule entity)
        {
            return Mapper.Map<LocalizedPageModule, LocalizedPageModuleModel>(entity);
        }

        public static List<LocalizedPageModule> ToEntities(this List<LocalizedPageModuleModel> models)
        {
            return Mapper.Map<List<LocalizedPageModuleModel>, List<LocalizedPageModule>>(models);
        }

        public static List<LocalizedPageModuleModel> ToModels(this List<LocalizedPageModule> entities)
        {
            return Mapper.Map<List<LocalizedPageModule>, List<LocalizedPageModuleModel>>(entities);
        }

        #endregion

        #region LocalizedPlugin

        public static LocalizedPlugin ToEntity(this LocalizedPluginModel model)
        {
            return Mapper.Map<LocalizedPluginModel, LocalizedPlugin>(model);
        }

        public static LocalizedPlugin ToEntity(this LocalizedPluginModel model, LocalizedPlugin entity)
        {
            return Mapper.Map<LocalizedPluginModel, LocalizedPlugin>(model, entity);
        }

        public static LocalizedPluginModel ToModel(this LocalizedPlugin entity)
        {
            return Mapper.Map<LocalizedPlugin, LocalizedPluginModel>(entity);
        }

        public static List<LocalizedPlugin> ToEntities(this List<LocalizedPluginModel> models)
        {
            return Mapper.Map<List<LocalizedPluginModel>, List<LocalizedPlugin>>(models);
        }

        public static List<LocalizedPluginModel> ToModels(this List<LocalizedPlugin> entities)
        {
            return Mapper.Map<List<LocalizedPlugin>, List<LocalizedPluginModel>>(entities);
        }

        #endregion

        #region LocalizedSite

        public static LocalizedSite ToEntity(this LocalizedSiteModel model)
        {
            return Mapper.Map<LocalizedSiteModel, LocalizedSite>(model);
        }

        public static LocalizedSite ToEntity(this LocalizedSiteModel model, LocalizedSite entity)
        {
            return Mapper.Map<LocalizedSiteModel, LocalizedSite>(model, entity);
        }

        public static LocalizedSiteModel ToModel(this LocalizedSite entity)
        {
            return Mapper.Map<LocalizedSite, LocalizedSiteModel>(entity);
        }

        public static List<LocalizedSite> ToEntities(this List<LocalizedSiteModel> models)
        {
            return Mapper.Map<List<LocalizedSiteModel>, List<LocalizedSite>>(models);
        }

        public static List<LocalizedSiteModel> ToModels(this List<LocalizedSite> entities)
        {
            return Mapper.Map<List<LocalizedSite>, List<LocalizedSiteModel>>(entities);
        }

        #endregion

        #region LocalizedTextVersion

        //public static LocalizedTextVersion ToEntity(this LocalizedTextVersionModel model)
        //{
        //    return Mapper.Map<LocalizedTextVersionModel, LocalizedTextVersion>(model);
        //}

        //public static LocalizedTextVersionModel ToModel(this LocalizedTextVersion entity)
        //{
        //    return Mapper.Map<LocalizedTextVersion, LocalizedTextVersionModel>(entity);
        //}

        //public static List<LocalizedTextVersion> ToEntities(this List<LocalizedTextVersionModel> models)
        //{
        //    return Mapper.Map<List<LocalizedTextVersionModel>, List<LocalizedTextVersion>>(models);
        //}

        //public static List<LocalizedTextVersionModel> ToModels(this List<LocalizedTextVersion> entities)
        //{
        //    return Mapper.Map<List<LocalizedTextVersion>, List<LocalizedTextVersionModel>>(entities);
        //}

        #endregion

        #region LocalizedWidget

        public static LocalizedWidget ToEntity(this LocalizedWidgetModel model)
        {
            return Mapper.Map<LocalizedWidgetModel, LocalizedWidget>(model);
        }

        public static LocalizedWidget ToEntity(this LocalizedWidgetModel model, LocalizedWidget entity)
        {
            return Mapper.Map<LocalizedWidgetModel, LocalizedWidget>(model, entity);
        }

        public static LocalizedWidgetModel ToModel(this LocalizedWidget entity)
        {
            return Mapper.Map<LocalizedWidget, LocalizedWidgetModel>(entity);
        }

        public static List<LocalizedWidget> ToEntities(this List<LocalizedWidgetModel> models)
        {
            return Mapper.Map<List<LocalizedWidgetModel>, List<LocalizedWidget>>(models);
        }

        public static List<LocalizedWidgetModel> ToModels(this List<LocalizedWidget> entities)
        {
            return Mapper.Map<List<LocalizedWidget>, List<LocalizedWidgetModel>>(entities);
        }

        #endregion

        #region MailTemplate

        public static MailTemplate ToEntity(this MailTemplateModel model)
        {
            return Mapper.Map<MailTemplateModel, MailTemplate>(model);
        }

        public static MailTemplate ToEntity(this MailTemplateModel model, MailTemplate entity)
        {
            return Mapper.Map<MailTemplateModel, MailTemplate>(model, entity);
        }

        public static MailTemplateModel ToModel(this MailTemplate entity)
        {
            return Mapper.Map<MailTemplate, MailTemplateModel>(entity);
        }

        public static List<MailTemplate> ToEntities(this List<MailTemplateModel> models)
        {
            return Mapper.Map<List<MailTemplateModel>, List<MailTemplate>>(models);
        }

        public static List<MailTemplateModel> ToModels(this List<MailTemplate> entities)
        {
            return Mapper.Map<List<MailTemplate>, List<MailTemplateModel>>(entities);
        }

        #endregion

        #region MailTemplateType

        public static MailTemplateType ToEntity(this MailTemplateTypeModel model)
        {
            return Mapper.Map<MailTemplateTypeModel, MailTemplateType>(model);
        }

        public static MailTemplateType ToEntity(this MailTemplateTypeModel model, MailTemplateType entity)
        {
            return Mapper.Map<MailTemplateTypeModel, MailTemplateType>(model, entity);
        }

        public static MailTemplateTypeModel ToModel(this MailTemplateType entity)
        {
            return Mapper.Map<MailTemplateType, MailTemplateTypeModel>(entity);
        }

        public static List<MailTemplateType> ToEntities(this List<MailTemplateTypeModel> models)
        {
            return Mapper.Map<List<MailTemplateTypeModel>, List<MailTemplateType>>(models);
        }

        public static List<MailTemplateTypeModel> ToModels(this List<MailTemplateType> entities)
        {
            return Mapper.Map<List<MailTemplateType>, List<MailTemplateTypeModel>>(entities);
        }

        #endregion

        #region MemberSettings

        public static MemberSettings ToEntity(this MemberSettingsModel model)
        {
            return Mapper.Map<MemberSettingsModel, MemberSettings>(model);
        }

        public static MemberSettings ToEntity(this MemberSettingsModel model, MemberSettings entity)
        {
            return Mapper.Map<MemberSettingsModel, MemberSettings>(model, entity);
        }

        public static MemberSettingsModel ToModel(this MemberSettings entity)
        {
            return Mapper.Map<MemberSettings, MemberSettingsModel>(entity);
        }

        #endregion

        #region Module

        public static Module ToEntity(this ModuleModel model)
        {
            return Mapper.Map<ModuleModel, Module>(model);
        }

        public static Module ToEntity(this ModuleModel model, Module entity)
        {
            return Mapper.Map<ModuleModel, Module>(model, entity);
        }

        public static ModuleModel ToModel(this Module entity)
        {
            return Mapper.Map<Module, ModuleModel>(entity);
        }

        public static List<Module> ToEntities(this List<ModuleModel> models)
        {
            return Mapper.Map<List<ModuleModel>, List<Module>>(models);
        }

        public static List<ModuleModel> ToModels(this List<Module> entities)
        {
            return Mapper.Map<List<Module>, List<ModuleModel>>(entities);
        }

        #endregion

        #region ModuleDefinition

        public static ModuleDefinition ToEntity(this ModuleDefinitionModel model)
        {
            return Mapper.Map<ModuleDefinitionModel, ModuleDefinition>(model);
        }

        public static ModuleDefinition ToEntity(this ModuleDefinitionModel model, ModuleDefinition entity)
        {
            return Mapper.Map<ModuleDefinitionModel, ModuleDefinition>(model, entity);
        }

        public static ModuleDefinitionModel ToModel(this ModuleDefinition entity)
        {
            return Mapper.Map<ModuleDefinition, ModuleDefinitionModel>(entity);
        }

        public static List<ModuleDefinition> ToEntities(this List<ModuleDefinitionModel> models)
        {
            return Mapper.Map<List<ModuleDefinitionModel>, List<ModuleDefinition>>(models);
        }

        public static List<ModuleDefinitionModel> ToModels(this List<ModuleDefinition> entities)
        {
            return Mapper.Map<List<ModuleDefinition>, List<ModuleDefinitionModel>>(entities);
        }

        #endregion

        #region ModuleTemplate

        public static ModuleTemplate ToEntity(this ModuleTemplateModel model)
        {
            return Mapper.Map<ModuleTemplateModel, ModuleTemplate>(model);
        }

        public static ModuleTemplate ToEntity(this ModuleTemplateModel model, ModuleTemplate entity)
        {
            return Mapper.Map<ModuleTemplateModel, ModuleTemplate>(model, entity);
        }

        public static ModuleTemplateModel ToModel(this ModuleTemplate entity)
        {
            return Mapper.Map<ModuleTemplate, ModuleTemplateModel>(entity);
        }

        public static List<ModuleTemplate> ToEntities(this List<ModuleTemplateModel> models)
        {
            return Mapper.Map<List<ModuleTemplateModel>, List<ModuleTemplate>>(models);
        }

        public static List<ModuleTemplateModel> ToModels(this List<ModuleTemplate> entities)
        {
            return Mapper.Map<List<ModuleTemplate>, List<ModuleTemplateModel>>(entities);
        }

        #endregion

        #region Page

        public static Page ToEntity(this PageModel model)
        {
            return Mapper.Map<PageModel, Page>(model);
        }

        public static Page ToEntity(this PageModel model, Page entity)
        {
            return Mapper.Map<PageModel, Page>(model, entity);
        }

        public static PageModel ToModel(this Page entity)
        {
            return Mapper.Map<Page, PageModel>(entity);
        }

        public static List<Page> ToEntities(this List<PageModel> models)
        {
            return Mapper.Map<List<PageModel>, List<Page>>(models);
        }

        public static List<PageModel> ToModels(this List<Page> entities)
        {
            return Mapper.Map<List<Page>, List<PageModel>>(entities);
        }

        #endregion

        #region PageModule

        public static PageModule ToEntity(this PageModuleModel model)
        {
            return Mapper.Map<PageModuleModel, PageModule>(model);
        }

        public static PageModule ToEntity(this PageModuleModel model, PageModule entity)
        {
            return Mapper.Map<PageModuleModel, PageModule>(model, entity);
        }

        public static PageModuleModel ToModel(this PageModule entity)
        {
            return Mapper.Map<PageModule, PageModuleModel>(entity);
        }

        public static List<PageModule> ToEntities(this List<PageModuleModel> models)
        {
            return Mapper.Map<List<PageModuleModel>, List<PageModule>>(models);
        }

        public static List<PageModuleModel> ToModels(this List<PageModule> entities)
        {
            return Mapper.Map<List<PageModule>, List<PageModuleModel>>(entities);
        }

        #endregion

        #region PageTemplate

        public static PageTemplate ToEntity(this PageTemplateModel model)
        {
            return Mapper.Map<PageTemplateModel, PageTemplate>(model);
        }

        public static PageTemplate ToEntity(this PageTemplateModel model, PageTemplate entity)
        {
            return Mapper.Map<PageTemplateModel, PageTemplate>(model, entity);
        }

        public static PageTemplateModel ToModel(this PageTemplate entity)
        {
            return Mapper.Map<PageTemplate, PageTemplateModel>(entity);
        }

        public static List<PageTemplate> ToEntities(this List<PageTemplateModel> models)
        {
            return Mapper.Map<List<PageTemplateModel>, List<PageTemplate>>(models);
        }

        public static List<PageTemplateModel> ToModels(this List<PageTemplate> entities)
        {
            return Mapper.Map<List<PageTemplate>, List<PageTemplateModel>>(entities);
        }

        #endregion

        #region Plugin

        public static Plugin ToEntity(this PluginModel model)
        {
            return Mapper.Map<PluginModel, Plugin>(model);
        }

        public static Plugin ToEntity(this PluginModel model, Plugin entity)
        {
            return Mapper.Map<PluginModel, Plugin>(model, entity);
        }

        public static PluginModel ToModel(this Plugin entity)
        {
            return Mapper.Map<Plugin, PluginModel>(entity);
        }

        public static List<Plugin> ToEntities(this List<PluginModel> models)
        {
            return Mapper.Map<List<PluginModel>, List<Plugin>>(models);
        }

        public static List<PluginModel> ToModels(this List<Plugin> entities)
        {
            return Mapper.Map<List<Plugin>, List<PluginModel>>(entities);
        }

        #endregion

        #region Plugin Definition

        public static PluginDefinition ToEntity(this PluginDefinitionModel model)
        {
            return Mapper.Map<PluginDefinitionModel, PluginDefinition>(model);
        }

        public static PluginDefinition ToEntity(this PluginDefinitionModel model, PluginDefinition entity)
        {
            return Mapper.Map<PluginDefinitionModel, PluginDefinition>(model, entity);
        }

        public static PluginDefinitionModel ToModel(this PluginDefinition entity)
        {
            return Mapper.Map<PluginDefinition, PluginDefinitionModel>(entity);
        }

        public static List<PluginDefinition> ToEntities(this List<PluginDefinitionModel> models)
        {
            return Mapper.Map<List<PluginDefinitionModel>, List<PluginDefinition>>(models);
        }

        public static List<PluginDefinitionModel> ToModels(this List<PluginDefinition> entities)
        {
            return Mapper.Map<List<PluginDefinition>, List<PluginDefinitionModel>>(entities);
        }

        #endregion

        #region SecuritySettings

        public static SecuritySettings ToEntity(this SecuritySettingsModel model)
        {
            return Mapper.Map<SecuritySettingsModel, SecuritySettings>(model);
        }

        public static SecuritySettings ToEntity(this SecuritySettingsModel model, SecuritySettings entity)
        {
            return Mapper.Map<SecuritySettingsModel, SecuritySettings>(model, entity);
        }

        public static SecuritySettingsModel ToModel(this SecuritySettings entity)
        {
            return Mapper.Map<SecuritySettings, SecuritySettingsModel>(entity);
        }

        #endregion

        #region Setting

        public static Setting ToEntity(this SettingModel model)
        {
            return Mapper.Map<SettingModel, Setting>(model);
        }

        public static Setting ToEntity(this SettingModel model, Setting entity)
        {
            return Mapper.Map<SettingModel, Setting>(model, entity);
        }

        public static SettingModel ToModel(this Setting entity)
        {
            return Mapper.Map<Setting, SettingModel>(entity);
        }

        public static List<Setting> ToEntities(this List<SettingModel> models)
        {
            return Mapper.Map<List<SettingModel>, List<Setting>>(models);
        }

        public static List<SettingModel> ToModels(this List<Setting> entities)
        {
            return Mapper.Map<List<Setting>, List<SettingModel>>(entities);
        }

        #endregion

        #region Site

        public static Site ToEntity(this SiteModel model)
        {
            return Mapper.Map<SiteModel, Site>(model);
        }

        public static Site ToEntity(this SiteModel model, Site entity)
        {
            return Mapper.Map<SiteModel, Site>(model, entity);
        }

        public static SiteModel ToModel(this Site entity)
        {
            return Mapper.Map<Site, SiteModel>(entity);
        }

        public static List<Site> ToEntities(this List<SiteModel> models)
        {
            return Mapper.Map<List<SiteModel>, List<Site>>(models);
        }

        public static List<SiteModel> ToModels(this List<Site> entities)
        {
            return Mapper.Map<List<Site>, List<SiteModel>>(entities);
        }

        #endregion

        #region Text

        //public static Text ToEntity(this TextModel model)
        //{
        //    return Mapper.Map<TextModel, Text>(model);
        //}

        //public static TextModel ToModel(this Text entity)
        //{
        //    return Mapper.Map<Text, TextModel>(entity);
        //}

        //public static List<Text> ToEntities(this List<TextModel> models)
        //{
        //    return Mapper.Map<List<TextModel>, List<Text>>(models);
        //}

        //public static List<TextModel> ToModels(this List<Text> entities)
        //{
        //    return Mapper.Map<List<Text>, List<TextModel>>(entities);
        //}

        #endregion

        #region TextVersion

        //public static TextVersion ToEntity(this TextVersionModel model)
        //{
        //    return Mapper.Map<TextVersionModel, TextVersion>(model);
        //}

        //public static TextVersionModel ToModel(this TextVersion entity)
        //{
        //    return Mapper.Map<TextVersion, TextVersionModel>(entity);
        //}

        //public static List<TextVersion> ToEntities(this List<TextVersionModel> models)
        //{
        //    return Mapper.Map<List<TextVersionModel>, List<TextVersion>>(models);
        //}

        //public static List<TextVersionModel> ToModels(this List<TextVersion> entities)
        //{
        //    return Mapper.Map<List<TextVersion>, List<TextVersionModel>>(entities);
        //}

        #endregion

        #region Theme

        public static Theme ToEntity(this ThemeModel model)
        {
            return Mapper.Map<ThemeModel, Theme>(model);
        }

        public static Theme ToEntity(this ThemeModel model, Theme entity)
        {
            return Mapper.Map<ThemeModel, Theme>(model, entity);
        }

        public static ThemeModel ToModel(this Theme entity)
        {
            return Mapper.Map<Theme, ThemeModel>(entity);
        }

        public static List<Theme> ToEntities(this List<ThemeModel> models)
        {
            return Mapper.Map<List<ThemeModel>, List<Theme>>(models);
        }

        public static List<ThemeModel> ToModels(this List<Theme> entities)
        {
            return Mapper.Map<List<Theme>, List<ThemeModel>>(entities);
        }

        #endregion

        #region User

        public static User ToEntity(this UserModel model)
        {
            return Mapper.Map<UserModel, User>(model);
        }

        public static User ToEntity(this UserModel model, User entity)
        {
            return Mapper.Map<UserModel, User>(model, entity);
        }

        public static UserModel ToModel(this User entity)
        {
            return Mapper.Map<User, UserModel>(entity);
        }

        public static List<User> ToEntities(this List<UserModel> models)
        {
            return Mapper.Map<List<UserModel>, List<User>>(models);
        }

        public static List<UserModel> ToModels(this List<User> entities)
        {
            return Mapper.Map<List<User>, List<UserModel>>(entities);
        }

        #endregion

        #region Widget

        public static Widget ToEntity(this WidgetModel model)
        {
            return Mapper.Map<WidgetModel, Widget>(model);
        }

        public static Widget ToEntity(this WidgetModel model, Widget entity)
        {
            return Mapper.Map<WidgetModel, Widget>(model, entity);
        }

        public static WidgetModel ToModel(this Widget entity)
        {
            return Mapper.Map<Widget, WidgetModel>(entity);
        }

        public static List<Widget> ToEntities(this List<WidgetModel> models)
        {
            return Mapper.Map<List<WidgetModel>, List<Widget>>(models);
        }

        public static List<WidgetModel> ToModels(this List<Widget> entities)
        {
            return Mapper.Map<List<Widget>, List<WidgetModel>>(entities);
        }

        #endregion

        #region Widget Definition

        public static WidgetDefinition ToEntity(this WidgetDefinitionModel model)
        {
            return Mapper.Map<WidgetDefinitionModel, WidgetDefinition>(model);
        }

        public static WidgetDefinition ToEntity(this WidgetDefinitionModel model, WidgetDefinition entity)
        {
            return Mapper.Map<WidgetDefinitionModel, WidgetDefinition>(model, entity);
        }

        public static WidgetDefinitionModel ToModel(this WidgetDefinition entity)
        {
            return Mapper.Map<WidgetDefinition, WidgetDefinitionModel>(entity);
        }

        public static List<WidgetDefinition> ToEntities(this List<WidgetDefinitionModel> models)
        {
            return Mapper.Map<List<WidgetDefinitionModel>, List<WidgetDefinition>>(models);
        }

        public static List<WidgetDefinitionModel> ToModels(this List<WidgetDefinition> entities)
        {
            return Mapper.Map<List<WidgetDefinition>, List<WidgetDefinitionModel>>(entities);
        }

        #endregion

	}

}