#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class EmailAccountModel : BaseAuditModel
    {
        public int SiteId { get; set; }

        [LocalizedDisplayName("Field_Address", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public string Address { get; set; }

        [LocalizedDisplayName("Field_DisplayName", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public string DisplayName { get; set; }

        [LocalizedDisplayName("Field_Host", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public string Host { get; set; }

        [LocalizedDisplayName("Field_Port", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public int Port { get; set; }

        [LocalizedDisplayName("Field_UserName", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public string UserName { get; set; }

        [DataType(DataType.Password)]
        [LocalizedDisplayName("Field_Password", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public string Password { get; set; }

        [LocalizedDisplayName("Field_DefaultCredentials", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public bool DefaultCredentials { get; set; }

        [LocalizedDisplayName("Field_Ssl", NameResourceType = typeof(Resources.Admin.EmailAccount))]
        public bool Ssl { get; set; }
    }
}