#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class LanguageModel : BaseAuditModel
    {
        public LanguageModel()
        {
            Active = true;
        }
    
        [Required]
        public int SiteId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.Language))]
        public string Name { get; set; }

        [Required]
        [LocalizedDisplayName("Field_CultureName", NameResourceType = typeof(Resources.Admin.Language))]
        public string CultureName { get; set; }

        [LocalizedDisplayName("Field_CultureNativeName", NameResourceType = typeof(Resources.Admin.Language))]
        public string CultureNativeName { get; set; }

        [LocalizedDisplayName("Field_CultureEnglishName", NameResourceType = typeof(Resources.Admin.Language))]
        public string CultureEnglishName { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Url", NameResourceType = typeof(Resources.Admin.Language))]
        public string Url { get; set; }

        [LocalizedDisplayName("Field_Flag", NameResourceType = typeof(Resources.Admin.Language))]
        public string Flag { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Active", NameResourceType = typeof(Resources.Admin.Language))]
        public bool Active { get; set; }

        [Required]
        [LocalizedDisplayName("Field_SortOrder", NameResourceType = typeof(Resources.Admin.Language))]
        public int SortOrder { get; set; }
    }
}