#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class LocalizedPageModel : BaseModel
    {
        [Required]
        public int PageId { get; set; }

        [Required]
        public int LanguageId { get; set; }
        public string LanguageName { get; set; }

        [LocalizedDisplayName("Field_Url", NameResourceType = typeof(Resources.Admin.Page))]
        public string Url { get; set; }

        [LocalizedDisplayName("Field_PageTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string PageTitle { get; set; }

        [LocalizedDisplayName("Field_PageImage", NameResourceType = typeof(Resources.Admin.Page))]
        public string PageImage { get; set; }

        [LocalizedDisplayName("Field_MenuText", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuText { get; set; }

        [LocalizedDisplayName("Field_MenuTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuTitle { get; set; }

        [LocalizedDisplayName("Field_Image", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuImage { get; set; }

        [LocalizedDisplayName("Field_MetaTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaTitle { get; set; }

        [LocalizedDisplayName("Field_MetaDescription", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaDescription { get; set; }

        [LocalizedDisplayName("Field_MetaKeywords", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaKeywords { get; set; }

        //public string Body { get; set; }
    }
}