#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class LocalizedSiteModel : BaseModel
    {
        [Required]
        public int SiteId { get; set; }
        [Required]
        public int LanguageId { get; set; }
        public string LanguageName { get; set; }
        public string Title { get; set; }

        [LocalizedDisplayName("Field_MetaTitle", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaTitle { get; set; }

        [LocalizedDisplayName("Field_MetaDescription", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaDescription { get; set; }

        [LocalizedDisplayName("Field_MetaKeywords", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaKeywords { get; set; }
    }
}