#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public partial class MailTemplateModel : BaseAuditModel
    {
        public MailTemplateModel()
        {
            this.LocalizedMailTemplateModels = new List<LocalizedMailTemplateModel>();
        }

        public int SiteId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public string Name { get; set; }

        [LocalizedDisplayName("Field_Description", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public string Description { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Subject", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public string Subject { get; set; }

        [Required]
        [LocalizedDisplayName("Field_BodyHtml", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public string BodyHtml { get; set; }

        [Required]
        [LocalizedDisplayName("Field_BodyPlain", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public string BodyPlain { get; set; }

        [LocalizedDisplayName("Field_MailTemplateTypeId", NameResourceType = typeof(Resources.Admin.MailTemplate))]
        public int MailTemplateTypeId { get; set; }
        public int MailTemplateTypeAppId { get; set; }
        public string MailTemplateTypeName { get; set; }
        public string MailTemplateTypeDescription { get; set; }
        public string MailTemplateTypeTokenController { get; set; }
        public string MailTemplateTypeTokenAction { get; set; }

        public string LocalizedSubject { get; set; }

        public virtual List<LocalizedMailTemplateModel> LocalizedMailTemplateModels { get; set; }

        public string TokenPath { get; set; }
    }
}