#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class ModuleDefinitionModel : BaseAuditModel
    {
        public ModuleDefinitionModel()
        {
            this.Apps = new Dictionary<string, string>();
        }

        [Required]
        [LocalizedDisplayName("Field_AppId", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public int AppId { get; set; }
        public string AppTitle { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string Name { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Title", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string Title { get; set; }

        [LocalizedDisplayName("Field_Description", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string Description { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Controller", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string Controller { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Action", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string Action { get; set; }

        [Required]
        [LocalizedDisplayName("Field_AdminController", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string AdminController { get; set; }

        [Required]
        [LocalizedDisplayName("Field_AdminAction", NameResourceType = typeof(Resources.Admin.ModuleDefinition))]
        public string AdminAction { get; set; }

        public Dictionary<string, string> Apps { get; set; }
    }
}