#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Services;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class ModuleModel : BaseAuditModel
    {
        public ModuleModel()
        {
            var _roleService = DependencyResolver.Current.GetService<IRoleService>();

            this.DisplayTitle = true;
            this.InheritPermissions = true;
            this.Authorized = _roleService.GetDefaultRoles(true, false, false);
            this.AllPages = false;
            this.Zone = "Content";

            //this.ModuleDefinitions = new Dictionary<int, string>();
            //this.LocalizedModules = new List<LocalizedModuleModel>();
        }

        public int SiteId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Title", NameResourceType = typeof(Resources.Admin.Module))]
        public string Title { get; set; }

        [LocalizedDisplayName("Field_DisplayTitle", NameResourceType = typeof(Resources.Admin.Module))]
        public bool DisplayTitle { get; set; }

        [LocalizedDisplayName("Field_AllPages", NameResourceType = typeof(Resources.Admin.Module))]
        public bool AllPages { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Zone", NameResourceType = typeof(Resources.Admin.Module))]
        public string Zone { get; set; }

        public bool Deleted { get; set; }

        [LocalizedDisplayName("Field_InheritPermissions", NameResourceType = typeof(Resources.Admin.Module))]
        public bool InheritPermissions { get; set; }

        [LocalizedDisplayName("Field_Authorized", NameResourceType = typeof(Resources.Admin.Module))]
        public string Authorized { get; set; }

        [LocalizedDisplayName("Field_StartDate", NameResourceType = typeof(Resources.Admin.Module))]
        public Nullable<DateTime> StartDate { get; set; }

        [LocalizedDisplayName("Field_EndDate", NameResourceType = typeof(Resources.Admin.Module))]
        public Nullable<DateTime> EndDate { get; set; }

        [Required]
        [LocalizedDisplayName("Field_ModuleDefinitionId", NameResourceType = typeof(Resources.Admin.Module))]
        public int ModuleDefinitionId { get; set; }
        public string ModuleDefinitionTitle { get; set; }
        public string ModuleDefinitionAdminController { get; set; }
        public string ModuleDefinitionAdminAction { get; set; }
        public int ModuleDefinitionAppId { get; set; }

        public int PageModuleCount { get; set; }

        //public Dictionary<int, string> ModuleDefinitions { get; set; }

        //public virtual List<LocalizedModuleModel> LocalizedModules { get; set; }
    }
}