#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class PageModel : BaseAuditModel
    {
        public PageModel()
        {
            this.Active = true;
            this.MainMenu = true;
            this.LanguageUrlEnabled = true;
            this.DisplayPageTitle = true;
            this.SiteMap = true;
            this.Disabled = false;
            this.SortOrder = 1;
            this.LocalizedPageModels = new List<LocalizedPageModel>();
        }
    
        public int SiteId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_ParentId", NameResourceType = typeof(Resources.Admin.Page))]
        public int ParentId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.Page))]
        public string Name { get; set; }

        [LocalizedDisplayName("Field_Url", NameResourceType = typeof(Resources.Admin.Page))]
        public string Url { get; set; }

        [LocalizedDisplayName("Field_PageTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string PageTitle { get; set; }

        [LocalizedDisplayName("Field_PageIcon", NameResourceType = typeof(Resources.Admin.Page))]
        public string PageIcon { get; set; }

        [LocalizedDisplayName("Field_PageImage", NameResourceType = typeof(Resources.Admin.Page))]
        public string PageImage { get; set; }

        [LocalizedDisplayName("Field_MenuText", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuText { get; set; }

        [LocalizedDisplayName("Field_MenuTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuTitle { get; set; }

        [LocalizedDisplayName("Field_Icon", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuIcon { get; set; }

        [LocalizedDisplayName("Field_Image", NameResourceType = typeof(Resources.Admin.Page))]
        public string MenuImage { get; set; }

        [LocalizedDisplayName("Field_MetaTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaTitle { get; set; }

        [LocalizedDisplayName("Field_MetaDescription", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaDescription { get; set; }

        [LocalizedDisplayName("Field_MetaKeywords", NameResourceType = typeof(Resources.Admin.Page))]
        public string MetaKeywords { get; set; }

        [LocalizedDisplayName("Field_PageTemplateId", NameResourceType = typeof(Resources.Admin.Page))]
        public int PageTemplateId { get; set; }
        public string PageTemplateName { get; set; }

        [LocalizedDisplayName("Field_ModuleTemplateId", NameResourceType = typeof(Resources.Admin.Page))]
        public int ModuleTemplateId { get; set; }
        public string ModuleTemplateName { get; set; }

        [LocalizedDisplayName("Field_Authorized", NameResourceType = typeof(Resources.Admin.Page))]
        public string Authorized { get; set; }

        [LocalizedDisplayName("Field_MainMenu", NameResourceType = typeof(Resources.Admin.Page))]
        public bool MainMenu { get; set; }

        [LocalizedDisplayName("Field_SortOrder", NameResourceType = typeof(Resources.Admin.Page))]
        public int SortOrder { get; set; }

        [LocalizedDisplayName("Field_Active", NameResourceType = typeof(Resources.Admin.Page))]
        public bool Active { get; set; }

        public bool Deleted { get; set; }

        [LocalizedDisplayName("Field_StartDate", NameResourceType = typeof(Resources.Admin.Page))]
        public Nullable<DateTime> StartDate { get; set; }

        [LocalizedDisplayName("Field_EndDate", NameResourceType = typeof(Resources.Admin.Page))]
        public Nullable<DateTime> EndDate { get; set; }

        [LocalizedDisplayName("Field_DisplayPageTitle", NameResourceType = typeof(Resources.Admin.Page))]
        public bool DisplayPageTitle { get; set; }

        [LocalizedDisplayName("Field_LanguageUrlEnabled", NameResourceType = typeof(Resources.Admin.Page))]
        public bool LanguageUrlEnabled { get; set; }

        [LocalizedDisplayName("Field_SiteMap", NameResourceType = typeof(Resources.Admin.Page))]
        public bool SiteMap { get; set; }

        [LocalizedDisplayName("Field_Link", NameResourceType = typeof(Resources.Admin.Page))]
        public string Link { get; set; }

        [LocalizedDisplayName("Field_Disabled", NameResourceType = typeof(Resources.Admin.Page))]
        public bool Disabled { get; set; }

        //public bool UseModules { get; set; }
        //public string Body { get; set; }

        public string LocalizedUrl { get; set; }
        public string LocalizedPageTitle { get; set; }
        public string LocalizedPageImage { get; set; }
        public string LocalizedMenuText { get; set; }
        public string LocalizedMenuTitle { get; set; }
        public string LocalizedMenuImage { get; set; }
        public string LocalizedMetaTitle { get; set; }
        public string LocalizedMetaDescription { get; set; }
        public string LocalizedMetaKeywords { get; set; }

        public string NameForTree { get; set; }

        public int PageModuleCount { get; set; }

        public List<LocalizedPageModel> LocalizedPageModels { get; set; }
    }
}