#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class PageModuleModel : BaseAuditModel
    {
        public PageModuleModel()
        {
            this.SortOrder = 1;
            this.Zone = "Content";
            //this.LocalizedPageModuleModels = new List<LocalizedPageModuleModel>();
        }

        [LocalizedDisplayName("Field_PageModule_Title", NameResourceType = typeof(Resources.Admin.Module))]
        public string Title { get; set; }

        [LocalizedDisplayName("Field_PageModule_Icon", NameResourceType = typeof(Resources.Admin.Module))]
        public string Icon { get; set; }

        [Required]
        [LocalizedDisplayName("Field_PageModule_Zone", NameResourceType = typeof(Resources.Admin.Module))]
        public string Zone { get; set; }

        [LocalizedDisplayName("Field_PageModule_ModuleTemplateId", NameResourceType = typeof(Resources.Admin.Module))]
        public int ModuleTemplateId { get; set; }
        public string ModuleTemplateName { get; set; }

        [Required]
        [LocalizedDisplayName("Field_PageModule_SortOrder", NameResourceType = typeof(Resources.Admin.Module))]
        public int SortOrder { get; set; }

        public bool Deleted { get; set; }

        public int PageId { get; set; }
        public string PageName { get; set; }

        [LocalizedDisplayName("Field_PageModule_ModuleId", NameResourceType = typeof(Resources.Admin.Module))]
        public int ModuleId { get; set; }
        //public string ModuleTitle { get; set; }
        //public bool ModuleInheritPermissions { get; set; }
        //public string ModuleAuthorized { get; set; }

        public int ModuleModuleDefinitionId { get; set; }
        public string ModuleModuleDefinitionTitle { get; set; }

        //public virtual IList<LocalizedPageModuleModel> LocalizedPageModuleModels { get; set; }
        public virtual ModuleModel Module { get; set; }
        //public virtual PageModel PageModel { get; set; }
    }
}