#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class PluginDefinitionModel : BaseAuditModel
    {
        public PluginDefinitionModel()
        {
            Apps = new Dictionary<string, string>();
        }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string Name { get; set; }

        [LocalizedDisplayName("Field_Description", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string Description { get; set; }

        [LocalizedDisplayName("Field_DashboardText", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string DashboardText { get; set; }

        [LocalizedDisplayName("Field_DashboardTitle", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string DashboardTitle { get; set; }

        [LocalizedDisplayName("Field_MenuText", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string MenuText { get; set; }

        [LocalizedDisplayName("Field_MenuTitle", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string MenuTitle { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Controller", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string Controller { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Action", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string Action { get; set; }

        [LocalizedDisplayName("Field_AdminController", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string AdminController { get; set; }

        [LocalizedDisplayName("Field_AdminAction", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string AdminAction { get; set; }

        [LocalizedDisplayName("Field_DashboardIcon", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string DashboardIcon { get; set; }

        [LocalizedDisplayName("Field_MenuIcon", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public string MenuIcon { get; set; }

        [LocalizedDisplayName("Field_TypeId", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public int TypeId { get; set; }
        public string TypeName { get; set; }

        [Required]
        [LocalizedDisplayName("Field_AppId", NameResourceType = typeof(Resources.Admin.PluginDefinition))]
        public int AppId { get; set; }
        public string AppTitle { get; set; }

        public Dictionary<string, string> Apps { get; set; }
    }
}