#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class PluginModel : BaseAuditModel
    {
        public PluginModel()
        {
            this.SortOrder = 1;
            this.Active = true;
            this.LocalizedPluginModels = new List<LocalizedPluginModel>();
        }

        public int SiteId { get; set; }

        [LocalizedDisplayName("Field_DashboardText", NameResourceType = typeof(Resources.Admin.Plugin))]
        public string DashboardText { get; set; }

        [LocalizedDisplayName("Field_DashboardTitle", NameResourceType = typeof(Resources.Admin.Plugin))]
        public string DashboardTitle { get; set; }

        [LocalizedDisplayName("Field_MenuText", NameResourceType = typeof(Resources.Admin.Plugin))]
        public string MenuText { get; set; }

        [LocalizedDisplayName("Field_MenuTitle", NameResourceType = typeof(Resources.Admin.Plugin))]
        public string MenuTitle { get; set; }

        [Required]
        [LocalizedDisplayName("Field_SortOrder", NameResourceType = typeof(Resources.Admin.Plugin))]
        public int SortOrder { get; set; }

        [LocalizedDisplayName("Field_Active", NameResourceType = typeof(Resources.Admin.Plugin))]
        public bool Active { get; set; }

        [LocalizedDisplayName("Field_Authorized", NameResourceType = typeof(Resources.Admin.Plugin))]
        public string Authorized { get; set; }

        public string LocalizedDashboardText { get; set; }
        public string LocalizedDashboardTitle { get; set; }
        public string LocalizedMenuText { get; set; }
        public string LocalizedMenuTitle { get; set; }

        [Required]
        [LocalizedDisplayName("Field_PluginDefinitionId", NameResourceType = typeof(Resources.Admin.Plugin))]
        public int PluginDefinitionId { get; set; }
        public string PluginDefinitionName { get; set; }
        public string PluginDefinitionAdminController { get; set; }
        public string PluginDefinitionAdminAction { get; set; }
        public int PluginDefinitionAppId { get; set; }

        public virtual List<LocalizedPluginModel> LocalizedPluginModels { get; set; }
    }
}