#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class SiteModel : BaseAuditModel
    {
        public SiteModel()
        {
            this.LocalizedSiteModels = new List<LocalizedSiteModel>();
        }

        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.Site))]
        public string Name { get; set; }

        [LocalizedDisplayName("Field_LanguageId", NameResourceType = typeof(Resources.Admin.Site))]
        public int LanguageId { get; set; }

        [LocalizedDisplayName("Field_LanguageSelectionEnabled", NameResourceType = typeof(Resources.Admin.Site))]
        public bool LanguageSelectionEnabled { get; set; }

        [LocalizedDisplayName("Field_LanguageUrlEnabled", NameResourceType = typeof(Resources.Admin.Site))]
        public bool LanguageUrlEnabled { get; set; }

        [LocalizedDisplayName("Field_ThemeId", NameResourceType = typeof(Resources.Admin.Site))]
        public int ThemeId { get; set; }

        [LocalizedDisplayName("Field_Title", NameResourceType = typeof(Resources.Admin.Site))]
        public string Title { get; set; }

        [LocalizedDisplayName("Field_MetaTitle", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaTitle { get; set; }

        [LocalizedDisplayName("Field_MetaDescription", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaDescription { get; set; }

        [LocalizedDisplayName("Field_MetaKeywords", NameResourceType = typeof(Resources.Admin.Site))]
        public string MetaKeywords { get; set; }

        [LocalizedDisplayName("Field_Closed", NameResourceType = typeof(Resources.Admin.Site))]
        public bool Closed { get; set; }

        [LocalizedDisplayName("Field_PageTemplateId", NameResourceType = typeof(Resources.Admin.Site))]
        public int PageTemplateId { get; set; }

        [LocalizedDisplayName("Field_ModuleTemplateId", NameResourceType = typeof(Resources.Admin.Site))]
        public int ModuleTemplateId { get; set; }

        [LocalizedDisplayName("Field_HomePageId", NameResourceType = typeof(Resources.Admin.Site))]
        public int HomePageId { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Copyright", NameResourceType = typeof(Resources.Admin.Site))]
        public string Copyright { get; set; }

        [LocalizedDisplayName("Field_Logo", NameResourceType = typeof(Resources.Admin.Site))]
        public string Logo { get; set; }

        [LocalizedDisplayName("Field_Url", NameResourceType = typeof(Resources.Admin.Site))]
        public string Url { get; set; }

        [LocalizedDisplayName("Field_RegisterMailTemplateId", NameResourceType = typeof(Resources.Admin.Site))]
        public int RegisterMailTemplateId { get; set; }

        [LocalizedDisplayName("Field_RegisterEmailAccountId", NameResourceType = typeof(Resources.Admin.Site))]
        public int RegisterEmailAccountId { get; set; }

        [LocalizedDisplayName("Field_PasswordRecoveryMailTemplateId", NameResourceType = typeof(Resources.Admin.Site))]
        public int PasswordRecoveryMailTemplateId { get; set; }

        [LocalizedDisplayName("Field_PasswordRecoveryEmailAccountId", NameResourceType = typeof(Resources.Admin.Site))]
        public int PasswordRecoveryEmailAccountId { get; set; }

        [LocalizedDisplayName("Field_ChangePasswordMailTemplateId", NameResourceType = typeof(Resources.Admin.Site))]
        public int ChangePasswordMailTemplateId { get; set; }

        [LocalizedDisplayName("Field_ChangePasswordEmailAccountId", NameResourceType = typeof(Resources.Admin.Site))]
        public int ChangePasswordEmailAccountId { get; set; }

        //public string AccountLayout { get; set; }
        //public string AdminLayout { get; set; }
        //public string AuthLayout { get; set; }
        //public string GroupLayout { get; set; }
        //public string ProfileLayout { get; set; }
        //public string SiteLayout { get; set; }

        public List<LocalizedSiteModel> LocalizedSiteModels { get; set; }

        public string FolderForFiles { get; set; }
        public string LogoImage { get; set; }
    }
}