#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class ThemeModel : BaseAuditModel
    {
        public ThemeModel()
        {
            this.SortOrder = 1;
        }

        [Required]
        [LocalizedDisplayName("Field_Name", NameResourceType = typeof(Resources.Admin.Theme))]
        public string Name { get; set; }

        [LocalizedDisplayName("Field_Description", NameResourceType = typeof(Resources.Admin.Theme))]
        public string Description { get; set; }

        [Required]
        [LocalizedDisplayName("Field_Folder", NameResourceType = typeof(Resources.Admin.Theme))]
        public string Folder { get; set; }

        [LocalizedDisplayName("Field_PreviewImage", NameResourceType = typeof(Resources.Admin.Theme))]
        public string PreviewImage { get; set; }

        [Required]
        [LocalizedDisplayName("Field_SortOrder", NameResourceType = typeof(Resources.Admin.Theme))]
        public int SortOrder { get; set; }
    }
}