#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Security;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    public class UserModel : BaseAuditModel
    {
        public UserModel()
        {
        }

        [Required]
        [LocalizedDisplayName("Field_DisplayName", NameResourceType = typeof(Resources.Admin.User))]
        public string DisplayName { get; set; }

        [LocalizedDisplayName("Field_ProfileName", NameResourceType = typeof(Resources.Admin.User))]
        public string ProfileName { get; set; }

        [LocalizedDisplayName("Field_MembershipName", NameResourceType = typeof(Resources.Admin.User))]
        public string MembershipName { get; set; }

        [Required]
        [LocalizedDisplayName("Field_MembershipEmail", NameResourceType = typeof(Resources.Admin.User))]
        [DataType(DataType.EmailAddress)]
        [RegularExpression(@"\b[a-zA-Z0-9._%\-+']+@[a-zA-Z0-9.\-]+\.[a-zA-Z]{2,4}\b", ErrorMessage = "Email not valid")]
        public string MembershipEmail { get; set; }

        public DateTime MembershipDate { get; set; }

        [LocalizedDisplayName("Field_IsApproved", NameResourceType = typeof(Resources.Admin.User))]
        public bool IsApproved { get; set; }

        [LocalizedDisplayName("Field_Comment", NameResourceType = typeof(Resources.Admin.User))]
        public string Comment { get; set; }

        public bool IsLockedOut { get; set; }
        public DateTime LastLockoutDate { get; set; }

        public string Roles { get; set; }

        //public MembershipUser MembershipUser { get; set; }

        //public bool Deleted { get; set; }
        //public string FirstName { get; set; }
        //public string MiddleName { get; set; }
        //public string LastName { get; set; }
        //public Nullable<byte> Gender { get; set; }
        //public string City { get; set; }
        //public Nullable<byte> BirthdayDay { get; set; }
        //public Nullable<byte> BirthdayMonth { get; set; }
        //public Nullable<byte> BirthdayYear { get; set; }
        //public int ProfileViews { get; set; }
        //public string ProfileImage { get; set; }
        //public byte MessengerAuthorized { get; set; }
        //public byte NameAuthorized { get; set; }
        //public byte CityAuthorized { get; set; }
        //public byte BirthdayAuthorized { get; set; }
        //public byte GenderAuthorized { get; set; }
        //public bool MessengerNotificationEmail { get; set; }
        //public bool FriendshipNotificationEmail { get; set; }
        //public int ThemeId { get; set; }
    }
}