#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Admin.Models
{
    using System;
    using System.Collections.Generic;
    using Weapsy.Web.Framework;

    public class WidgetModel : BaseAuditModel
    {
        public WidgetModel()
        {
            this.SortOrder = 1;
            this.Active = true;
            this.LocalizedWidgetModels = new List<LocalizedWidgetModel>();
        }
    
        public int SiteId { get; set; }

        [LocalizedDisplayName("Field_Title", NameResourceType = typeof(Resources.Admin.Widget))]
        public string Title { get; set; }

        [Required]
        [LocalizedDisplayName("Field_SortOrder", NameResourceType = typeof(Resources.Admin.Widget))]
        public int SortOrder { get; set; }

        [LocalizedDisplayName("Field_Active", NameResourceType = typeof(Resources.Admin.Widget))]
        public bool Active { get; set; }

        [LocalizedDisplayName("Field_Authorized", NameResourceType = typeof(Resources.Admin.Widget))]
        public string Authorized { get; set; }

        public string LocalizedTitle { get; set; }

        [Required]
        [LocalizedDisplayName("Field_WidgetDefinitionId", NameResourceType = typeof(Resources.Admin.Widget))]
        public int WidgetDefinitionId { get; set; }
        public string WidgetDefinitionName { get; set; }
        public string WidgetDefinitionAdminController { get; set; }
        public string WidgetDefinitionAdminAction { get; set; }
        public int WidgetDefinitionAppId { get; set; }

        public virtual List<LocalizedWidgetModel> LocalizedWidgetModels { get; set; }
    }
}