#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using Weapsy.Core.Tasks;
using Weapsy.Entities;
using Weapsy.Web.Admin.Models;
using AutoMapper;

namespace Weapsy.Web.Admin.Tasks
{
    public class AutoMapperStartupTask : IStartupTask
    {
        public void Execute()
        {
            Create<App, AppModel>();
            Create<EmailAccount, EmailAccountModel>();
            //Create<CacheSettings, CacheSettingsModel>();
            Create<Language, LanguageModel>();
            Create<LocalizedMailTemplate, LocalizedMailTemplateModel>();
            Create<LocalizedModule, LocalizedModuleModel>();
            Create<LocalizedPage, LocalizedPageModel>();
            Create<LocalizedPageModule, LocalizedPageModuleModel>();
            Create<LocalizedPlugin, LocalizedPluginModel>();
            Create<LocalizedSite, LocalizedSiteModel>();
            Create<LocalizedWidget, LocalizedWidgetModel>();
            Create<MailTemplate, MailTemplateModel>();
            Create<MailTemplateType, MailTemplateTypeModel>();
            Create<MemberSettings, MemberSettingsModel>();
            Create<ModuleDefinition, ModuleDefinitionModel>();
            Create<Module, ModuleModel>();
            Create<ModuleTemplate, ModuleTemplateModel>();
            Create<Page, PageModel>();
            Create<PageModule, PageModuleModel>();
            Create<PageTemplate, PageTemplateModel>();
            Create<Plugin, PluginModel>();
            Create<PluginDefinition, PluginDefinitionModel>();
            Create<SecuritySettings, SecuritySettingsModel>();
            Create<Setting, SettingModel>();
            Create<Site, SiteModel>();
            Create<Theme, ThemeModel>();
            Create<User, UserModel>();
            Create<Widget, WidgetModel>();
            Create<WidgetDefinition, WidgetDefinitionModel>();

            //Mapper.CreateMap<ModuleDefinition, ModuleDefinitionModel>()
            //  .ForMember(m => m.AppId, o => o.MapFrom(e => e.App == null ? (int?)null : e.App.Id))
            //  .ForMember(m => m.AppTitle, o => o.MapFrom(e => e.App == null ? null : e.App.Title));
            //Mapper.CreateMap<ModuleDefinitionModel, ModuleDefinition>();

        }

        protected virtual void Create<T1, T2>()
        {
            Mapper.CreateMap<T1, T2>();
            Mapper.CreateMap<T2, T1>();
        }
    }
}