﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration.Conventions;
using Weapsy.Data;
using Weapsy.Entities;
using Weapsy.Apps.Forum.Data.Mapping;

namespace Weapsy.Apps.Forum.Data
{
    public partial class ForumContext : DbContext, IDbContext
    {
        public ForumContext()
            : base("name=WeapsyConnection")
        {
            Database.SetInitializer<ForumContext>(null);
        }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Conventions.Remove<PluralizingTableNameConvention>();

            modelBuilder.Configurations.Add(new ForumCategoryMap());
            modelBuilder.Configurations.Add(new ForumConfigurationMap());
            modelBuilder.Configurations.Add(new ForumPermissionSetMap());
            modelBuilder.Configurations.Add(new ForumPostMap());
            modelBuilder.Configurations.Add(new ForumSectionMap());
            modelBuilder.Configurations.Add(new ForumSettingSetMap());
            modelBuilder.Configurations.Add(new ForumUserMap());

            base.OnModelCreating(modelBuilder);
        }

        public new IDbSet<TEntity> Set<TEntity>() where TEntity : BaseEntity
        {
            return base.Set<TEntity>();
        }

    }
}