#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Apps.Forum.Entities;
using Weapsy.Apps.Forum.Models.AdminModels;
using AutoMapper;

namespace Weapsy.Apps.Forum.Extensions
{
	public static class MappingExtensions
    {
        #region Category

        public static ForumCategory ToEntity(this ForumCategoryModel model)
        {
            return Mapper.Map<ForumCategoryModel, ForumCategory>(model);
        }

        public static ForumCategory ToEntity(this ForumCategoryModel model, ForumCategory entity)
        {
            return Mapper.Map<ForumCategoryModel, ForumCategory>(model, entity);
        }

        public static ForumCategoryModel ToModel(this ForumCategory entity)
        {
            return Mapper.Map<ForumCategory, ForumCategoryModel>(entity);
        }

        public static List<ForumCategory> ToEntities(this List<ForumCategoryModel> models)
        {
            return Mapper.Map<List<ForumCategoryModel>, List<ForumCategory>>(models);
        }

        public static List<ForumCategoryModel> ToModels(this List<ForumCategory> entities)
        {
            return Mapper.Map<List<ForumCategory>, List<ForumCategoryModel>>(entities);
        }

        #endregion

        #region Configuration

        public static ForumConfiguration ToEntity(this ForumConfigurationModel model)
        {
            return Mapper.Map<ForumConfigurationModel, ForumConfiguration>(model);
        }

        public static ForumConfiguration ToEntity(this ForumConfigurationModel model, ForumConfiguration entity)
        {
            return Mapper.Map<ForumConfigurationModel, ForumConfiguration>(model, entity);
        }

        public static ForumConfigurationModel ToModel(this ForumConfiguration entity)
        {
            return Mapper.Map<ForumConfiguration, ForumConfigurationModel>(entity);
        }

        public static List<ForumConfiguration> ToEntities(this List<ForumConfigurationModel> models)
        {
            return Mapper.Map<List<ForumConfigurationModel>, List<ForumConfiguration>>(models);
        }

        public static List<ForumConfigurationModel> ToModels(this List<ForumConfiguration> entities)
        {
            return Mapper.Map<List<ForumConfiguration>, List<ForumConfigurationModel>>(entities);
        }

        #endregion

        #region PermissionSet

        public static ForumPermissionSet ToEntity(this ForumPermissionSetModel model)
        {
            return Mapper.Map<ForumPermissionSetModel, ForumPermissionSet>(model);
        }

        public static ForumPermissionSet ToEntity(this ForumPermissionSetModel model, ForumPermissionSet entity)
        {
            return Mapper.Map<ForumPermissionSetModel, ForumPermissionSet>(model, entity);
        }

        public static ForumPermissionSetModel ToModel(this ForumPermissionSet entity)
        {
            return Mapper.Map<ForumPermissionSet, ForumPermissionSetModel>(entity);
        }

        public static List<ForumPermissionSet> ToEntities(this List<ForumPermissionSetModel> models)
        {
            return Mapper.Map<List<ForumPermissionSetModel>, List<ForumPermissionSet>>(models);
        }

        public static List<ForumPermissionSetModel> ToModels(this List<ForumPermissionSet> entities)
        {
            return Mapper.Map<List<ForumPermissionSet>, List<ForumPermissionSetModel>>(entities);
        }

        #endregion

        #region Post

        public static ForumPost ToEntity(this ForumPostModel model)
        {
            return Mapper.Map<ForumPostModel, ForumPost>(model);
        }

        public static ForumPost ToEntity(this ForumPostModel model, ForumPost entity)
        {
            return Mapper.Map<ForumPostModel, ForumPost>(model, entity);
        }

        public static ForumPostModel ToModel(this ForumPost entity)
        {
            return Mapper.Map<ForumPost, ForumPostModel>(entity);
        }

        public static List<ForumPost> ToEntities(this List<ForumPostModel> models)
        {
            return Mapper.Map<List<ForumPostModel>, List<ForumPost>>(models);
        }

        public static List<ForumPostModel> ToModels(this List<ForumPost> entities)
        {
            return Mapper.Map<List<ForumPost>, List<ForumPostModel>>(entities);
        }

        #endregion

        #region Section

        public static ForumSection ToEntity(this ForumSectionModel model)
        {
            return Mapper.Map<ForumSectionModel, ForumSection>(model);
        }

        public static ForumSection ToEntity(this ForumSectionModel model, ForumSection entity)
        {
            return Mapper.Map<ForumSectionModel, ForumSection>(model, entity);
        }

        public static ForumSectionModel ToModel(this ForumSection entity)
        {
            return Mapper.Map<ForumSection, ForumSectionModel>(entity);
        }

        public static List<ForumSection> ToEntities(this List<ForumSectionModel> models)
        {
            return Mapper.Map<List<ForumSectionModel>, List<ForumSection>>(models);
        }

        public static List<ForumSectionModel> ToModels(this List<ForumSection> entities)
        {
            return Mapper.Map<List<ForumSection>, List<ForumSectionModel>>(entities);
        }

        #endregion

        #region SettingSet

        public static ForumSettingSet ToEntity(this ForumSettingSetModel model)
        {
            return Mapper.Map<ForumSettingSetModel, ForumSettingSet>(model);
        }

        public static ForumSettingSet ToEntity(this ForumSettingSetModel model, ForumSettingSet entity)
        {
            return Mapper.Map<ForumSettingSetModel, ForumSettingSet>(model, entity);
        }

        public static ForumSettingSetModel ToModel(this ForumSettingSet entity)
        {
            return Mapper.Map<ForumSettingSet, ForumSettingSetModel>(entity);
        }

        public static List<ForumSettingSet> ToEntities(this List<ForumSettingSetModel> models)
        {
            return Mapper.Map<List<ForumSettingSetModel>, List<ForumSettingSet>>(models);
        }

        public static List<ForumSettingSetModel> ToModels(this List<ForumSettingSet> entities)
        {
            return Mapper.Map<List<ForumSettingSet>, List<ForumSettingSetModel>>(entities);
        }

        #endregion

        #region User

        public static ForumUser ToEntity(this ForumUserModel model)
        {
            return Mapper.Map<ForumUserModel, ForumUser>(model);
        }

        public static ForumUser ToEntity(this ForumUserModel model, ForumUser entity)
        {
            return Mapper.Map<ForumUserModel, ForumUser>(model, entity);
        }

        public static ForumUserModel ToModel(this ForumUser entity)
        {
            return Mapper.Map<ForumUser, ForumUserModel>(entity);
        }

        public static List<ForumUser> ToEntities(this List<ForumUserModel> models)
        {
            return Mapper.Map<List<ForumUserModel>, List<ForumUser>>(models);
        }

        public static List<ForumUserModel> ToModels(this List<ForumUser> entities)
        {
            return Mapper.Map<List<ForumUser>, List<ForumUserModel>>(entities);
        }

        #endregion
	}
}