#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using Weapsy.Data;
using Weapsy.Apps.Forum.Data;
using Weapsy.Apps.Forum.Entities;
using Weapsy.Apps.Forum.Services;
using Autofac;
using Autofac.Core;
using Autofac.Integration.Mvc;

namespace Weapsy.Apps.Forum
{
    public class InjectionModule : Autofac.Module
    {
        //private const string ContextName = "WeapsyForumContext";

        protected override void Load(ContainerBuilder builder)
        {
            if (builder == null) 
                throw new ArgumentNullException("builder");

            // register dbcontext
            //builder.Register<IDbContext>(c => new ForumContext()).Named<IDbContext>(ContextName).InstancePerHttpRequest();

            // register repositories
            //builder.RegisterType<EfRepository<ForumCategory>>().As<IRepository<ForumCategory>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumConfiguration>>().As<IRepository<ForumConfiguration>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumPermissionSet>>().As<IRepository<ForumPermissionSet>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumPost>>().As<IRepository<ForumPost>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumSection>>().As<IRepository<ForumSection>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumSettingSet>>().As<IRepository<ForumSettingSet>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();
            //builder.RegisterType<EfRepository<ForumUser>>().As<IRepository<ForumUser>>().WithParameter(ResolvedParameter.ForNamed<IDbContext>(ContextName)).InstancePerHttpRequest();

            // register services
            builder.RegisterType<CategoryService>().As<ICategoryService>();
            builder.RegisterType<ConfigurationService>().As<IConfigurationService>();
            builder.RegisterType<InstallService>().As<IInstallService>();
            builder.RegisterType<PermissionSetService>().As<IPermissionSetService>();
            //builder.RegisterType<PostService>().As<IPostService>();
            builder.RegisterType<SectionService>().As<ISectionService>();
            builder.RegisterType<SettingSetService>().As<ISettingSetService>();
            //builder.RegisterType<UserService>().As<IUserService>();
        }
    }
}