#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Apps.Forum.Models.AdminModels
{    
    public partial class ForumCategoryModel : BaseAuditModel
    {
        public ForumCategoryModel()
        {
            this.SortOrder = 1;
            this.Active = true;
        }

        [Required]
        public int ConfigurationId { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_Name", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Name { get; set; }

        [LocalizedDisplayName("Category_Field_Url", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Url { get; set; }

        [LocalizedDisplayName("Category_Field_Description", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Description { get; set; }

        [LocalizedDisplayName("Category_Field_Notes", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Notes { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_SortOrder", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int SortOrder { get; set; }

        [LocalizedDisplayName("Category_Field_IconImage", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string IconImage { get; set; }

        [LocalizedDisplayName("Category_Field_NameImage", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string NameImage { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_Closed", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public bool Closed { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_Active", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public bool Active { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_SettingSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int SettingSetId { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_PermissionSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int PermissionSetId { get; set; }

        [Required]
        [LocalizedDisplayName("Category_Field_Authorized", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Authorized { get; set; }

        public int Topics { get; set; }
        public int Replies { get; set; }
    }
}