#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Apps.Forum.Models.AdminModels
{    
    public partial class ForumConfigurationModel : BaseAuditModel
    {
        [Required]
        public int SiteId { get; set; }

        [Required]
        [LocalizedDisplayName("Configuration_Field_Name", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Name { get; set; }

        [LocalizedDisplayName("Configuration_Field_Description", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Description { get; set; }

        [Required]
        [LocalizedDisplayName("Configuration_Field_Enabled", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public bool Enabled { get; set; }

        [Required]
        [LocalizedDisplayName("Configuration_Field_SettingSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int SettingSetId { get; set; }

        [Required]
        [LocalizedDisplayName("Configuration_Field_PermissionSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int PermissionSetId { get; set; }
    }
}