#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Apps.Forum.Models.AdminModels
{
    public partial class ForumPermissionSetModel : BaseAuditModel
    {
        [Required]
        public int ConfigurationId { get; set; }

        [Required]
        [LocalizedDisplayName("PermissionSet_Field_Name", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Name { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_Description", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Description { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_ViewSection", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string ViewSection { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_ViewTopics", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string ViewTopics { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_Read", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Read { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_Start", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Start { get; set; }

        [LocalizedDisplayName("PermissionSet_Field_Reply", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Reply { get; set; }

        //public string Upload { get; set; }
        //public string Download { get; set; }
        //public string SubscribeSection { get; set; }
        //public string SubscribeTopic { get; set; }
        //public string Edit { get; set; }
        //public string Delete { get; set; }
        //public string Pin { get; set; }
        //public string Lock { get; set; }
        //public string Moderate { get; set; }
        //public string VotePoll { get; set; }
        //public string CreatePoll { get; set; }
        //public string SelectStatus { get; set; }
        //public string Announce { get; set; }
        //public string RateTopics { get; set; }
    }
}