#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Apps.Forum.Models.AdminModels
{    
    public partial class ForumSectionModel : BaseAuditModel
    {
        public ForumSectionModel()
        {
            this.Active = true;
            this.SortOrder = 1;
        }

        [Required]
        [LocalizedDisplayName("Section_Field_CategoryId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int CategoryId { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_Name", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Name { get; set; }

        [LocalizedDisplayName("Section_Field_Url", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Url { get; set; }

        [LocalizedDisplayName("Section_Field_Description", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Description { get; set; }

        [LocalizedDisplayName("Section_Field_Notes", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string Notes { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_ParentId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int ParentId { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_SortOrder", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int SortOrder { get; set; }

        [LocalizedDisplayName("Section_Field_IconImage", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string IconImage { get; set; }

        [LocalizedDisplayName("Section_Field_NameImage", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string NameImage { get; set; }

        [LocalizedDisplayName("Section_Field_SectionImage", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public string SectionImage { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_Type", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int Type { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_Closed", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public bool Closed { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_Active", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public bool Active { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_SettingSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int SettingSetId { get; set; }

        [Required]
        [LocalizedDisplayName("Section_Field_PermissionSetId", NameResourceType = typeof(Resources.Apps.Forum.Admin))]
        public int PermissionSetId { get; set; }

        //public int Topics { get; set; }
        //public int Replies { get; set; }
    }
}