#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Weapsy.Apps.Forum.Entities;

namespace Weapsy.Apps.Forum.Services
{
	public interface ICategoryService
    {
        void Create(ForumCategory entity);

        void Update(ForumCategory entity);

        void Delete(ForumCategory entity);

        ForumCategory GetById(int configurationId, int id);
        ForumCategory GetById(int configurationId, int id, bool useCache);

        ForumCategory GetByUrl(int configurationId, string url);
        ForumCategory GetByUrl(int configurationId, string url, bool useCache);

        ForumCategory GetByName(int configurationId, string name);
        ForumCategory GetByName(int configurationId, string name, bool useCache);

        List<ForumCategory> GetList(int configurationId);
        List<ForumCategory> GetList(int configurationId, bool useCache);

        Dictionary<string, string> GetDictionary(int configurationId);

        void Move(int configurationId, int Id, string Action);
	}
}