#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using Weapsy.Core.Tasks;
using Weapsy.Apps.Forum.Entities;
using Weapsy.Apps.Forum.Models.AdminModels;
using AutoMapper;

namespace Weapsy.Apps.Forum.Tasks
{
    public class AutoMapperStartupTask : IStartupTask
    {
        public void Execute()
        {
            Create<ForumCategory, ForumCategoryModel>();
            Create<ForumConfiguration, ForumConfigurationModel>();
            Create<ForumPermissionSet, ForumPermissionSetModel>();
            Create<ForumPost, ForumPostModel>();
            Create<ForumSection, ForumSectionModel>();
            Create<ForumSettingSet, ForumSettingSetModel>();
            Create<ForumUser, ForumUserModel>();
        }

        protected virtual void Create<T1, T2>()
        {
            Mapper.CreateMap<T1, T2>();
            Mapper.CreateMap<T2, T1>();
        }
    }
}