﻿#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.ModelConfiguration;
using System.Data.Entity.ModelConfiguration.Conventions;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Web.Management;
using Weapsy.Data;
using Weapsy.Data.Initializers;
using Weapsy.Data.Mapping;
using Weapsy.Entities;

namespace Weapsy.Web.Modules.Data
{
    public partial class ModulesContext : DbContext, IDbContext
    {
        public ModulesContext()
            : base("name=WeapsyConnection")
        {
            if (AppDomain.CurrentDomain.IsFullyTrusted)
            {
                //Database.SetInitializer(new MigrationInitializer());
                //Database.SetInitializer(new DropCreateInitializer());
            }
            else
            {
                Database.SetInitializer(new ValidateDatabaseInitializer<WeapsyContext>());
            }
        }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Configurations.Add(new LocalizedTextVersionMap());
            modelBuilder.Configurations.Add(new TextMap());
            modelBuilder.Configurations.Add(new TextVersionMap());

            base.OnModelCreating(modelBuilder);
        }

        public new IDbSet<TEntity> Set<TEntity>() where TEntity : BaseEntity
        {
            return base.Set<TEntity>();
        }

    }
}