#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Web.Models.Account;
using Weapsy.Web.Plugins.Models.Account;
using Weapsy.Web.Models.Home;
using Weapsy.Web.Modules.Models.Text;
using AutoMapper;

namespace Weapsy.Web.Modules.Extensions
{
    public static class MappingExtensions
    {

        #region LocalizedTextVersion

        public static Entities.LocalizedTextVersion ToEntity(this LocalizedTextVersionModel model)
        {
            return Mapper.Map<LocalizedTextVersionModel, Entities.LocalizedTextVersion>(model);
        }

        public static Entities.LocalizedTextVersion ToEntity(this LocalizedTextVersionModel model, Entities.LocalizedTextVersion entity)
        {
            return Mapper.Map<LocalizedTextVersionModel, Entities.LocalizedTextVersion>(model, entity);
        }

        public static LocalizedTextVersionModel ToModel(this Entities.LocalizedTextVersion entity)
        {
            return Mapper.Map<Entities.LocalizedTextVersion, LocalizedTextVersionModel>(entity);
        }

        public static List<Entities.LocalizedTextVersion> ToEntities(this List<LocalizedTextVersionModel> models)
        {
            return Mapper.Map<List<LocalizedTextVersionModel>, List<Entities.LocalizedTextVersion>>(models);
        }

        public static List<LocalizedTextVersionModel> ToModels(this List<Entities.LocalizedTextVersion> entities)
        {
            return Mapper.Map<List<Entities.LocalizedTextVersion>, List<LocalizedTextVersionModel>>(entities);
        }

        #endregion

        #region Text

        public static Entities.Text ToEntity(this TextModel model)
        {
            return Mapper.Map<TextModel, Entities.Text>(model);
        }

        public static Entities.Text ToEntity(this TextModel model, Entities.Text entity)
        {
            return Mapper.Map<TextModel, Entities.Text>(model, entity);
        }

        public static TextModel ToModel(this Entities.Text entity)
        {
            return Mapper.Map<Entities.Text, TextModel>(entity);
        }

        public static List<Entities.Text> ToEntities(this List<TextModel> models)
        {
            return Mapper.Map<List<TextModel>, List<Entities.Text>>(models);
        }

        public static List<TextModel> ToModels(this List<Entities.Text> entities)
        {
            return Mapper.Map<List<Entities.Text>, List<TextModel>>(entities);
        }

        #endregion

        #region TextVersion

        public static Entities.TextVersion ToEntity(this TextVersionModel model)
        {
            return Mapper.Map<TextVersionModel, Entities.TextVersion>(model);
        }

        public static Entities.TextVersion ToEntity(this TextVersionModel model, Entities.TextVersion entity)
        {
            return Mapper.Map<TextVersionModel, Entities.TextVersion>(model, entity);
        }

        public static TextVersionModel ToModel(this Entities.TextVersion entity)
        {
            return Mapper.Map<Entities.TextVersion, TextVersionModel>(entity);
        }

        public static List<Entities.TextVersion> ToEntities(this List<TextVersionModel> models)
        {
            return Mapper.Map<List<TextVersionModel>, List<Entities.TextVersion>>(models);
        }

        public static List<TextVersionModel> ToModels(this List<Entities.TextVersion> entities)
        {
            return Mapper.Map<List<Entities.TextVersion>, List<TextVersionModel>>(entities);
        }

        #endregion

    }
}