#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Web.Framework.DataAnnotations;
using Weapsy.Web.Framework;
using Weapsy.Web.Framework.Models;

namespace Weapsy.Web.Modules.Models.Text
{
    public class TextVersionModel : BaseAuditModel
    {
        public TextVersionModel()
        {
            //this.LocalizedTextVersionModels = new List<LocalizedTextVersionModel>();
        }

        public int TextId { get; set; }

        [LocalizedDisplayName("Field_Description", NameResourceType = typeof(Resources.Modules.Text))]
        public string Description { get; set; }

        [LocalizedDisplayName("Field_Body", NameResourceType = typeof(Resources.Modules.Text))]
        public string Body { get; set; }

        public string NameForSelectList
        {
            get
            {
                DateTime date = this.ModifiedOnDate.ToLocalTime();
                string result = date.ToShortDateString() + " " + date.ToShortTimeString();
                if (!string.IsNullOrWhiteSpace(this.Description))
                {
                    result += " (" + this.Description + ")";
                }
                return result;
            }
        }

        //public virtual IList<LocalizedTextVersionModel> LocalizedTextVersionModels { get; set; }
    }
}