#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using Weapsy.Core.Tasks;
using Weapsy.Web.Models.Account;
using Weapsy.Web.Plugins.Models.Account;
using Weapsy.Web.Models.Home;
using Weapsy.Web.Modules.Models.Text;
using AutoMapper;

namespace Weapsy.Web.Modules.Tasks
{
    public class AutoMapperStartupTask : IStartupTask
    {
        public void Execute()
        {
            Create<Entities.LocalizedTextVersion, LocalizedTextVersionModel>();
            Create<Entities.Text, TextModel>();
            Create<Entities.TextVersion, TextVersionModel>();
        }   

        protected virtual void Create<T1, T2>()
        {
            Mapper.CreateMap<T1, T2>();
            Mapper.CreateMap<T2, T1>();
        }
    }
}