#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using System.Web.Mvc;
using Weapsy.Web.Framework.DataAnnotations;

namespace Weapsy.Web.Plugins.Models.Account
{
    public class ChangePasswordModel
    {
        [Required]
        [DataType(DataType.Password)]
        [LocalizedDisplayName("ChangePassword_Field_CurrentPassword", NameResourceType = typeof(Resources.Plugins.Account))]
        public string OldPassword { get; set; }

        [Required]
        [StringLength(100, ErrorMessageResourceName = "ChangePassword_Field_NewPasswordLengthErrorMessage", ErrorMessageResourceType = typeof(Resources.Plugins.Account), MinimumLength = 6)]
        [DataType(DataType.Password)]
        [LocalizedDisplayName("ChangePassword_Field_NewPassword", NameResourceType = typeof(Resources.Plugins.Account))]
        public string NewPassword { get; set; }

        [DataType(DataType.Password)]
        [LocalizedDisplayName("ChangePassword_Field_ConfirmNewPassword", NameResourceType = typeof(Resources.Plugins.Account))]
        [Compare("NewPassword", ErrorMessageResourceName = "ChangePassword_Field_ComparePasswordErrorMessage", ErrorMessageResourceType = typeof(Resources.Plugins.Account))]
        public string ConfirmPassword { get; set; }
    }
}