#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Collections.Generic;
using Weapsy.Web.Models.Account;
using Weapsy.Web.Plugins.Models.Account;
using Weapsy.Web.Models.Home;
using Weapsy.Web.Modules.Models.Text;
using AutoMapper;

namespace Weapsy.Web.Extensions
{
    public static class MappingExtensions
    {

        #region Module

        public static ModuleSharedSettingsModel ToModel(this Entities.Module entity)
        {
            return Mapper.Map<Entities.Module, ModuleSharedSettingsModel>(entity);
        }

        #endregion

        #region ModuleDefinition

        public static ModuleDefinitionModel ToModel(this Entities.ModuleDefinition entity)
        {
            return Mapper.Map<Entities.ModuleDefinition, ModuleDefinitionModel>(entity);
        }

        #endregion

        #region ModuleTemplate

        public static ModuleTemplateModel ToModel(this Entities.ModuleTemplate entity)
        {
            return Mapper.Map<Entities.ModuleTemplate, ModuleTemplateModel>(entity);
        }

        #endregion

        #region Page

        public static PageModel ToModel(this Entities.Page entity)
        {
            return Mapper.Map<Entities.Page, PageModel>(entity);
        }

        #endregion

        #region PageModule

        public static ModulePageSettingsModel ToModel(this Entities.PageModule entity)
        {
            return Mapper.Map<Entities.PageModule, ModulePageSettingsModel>(entity);
        }

        #endregion

        #region PageTemplate

        public static PageTemplateModel ToModel(this Entities.PageTemplate entity)
        {
            return Mapper.Map<Entities.PageTemplate, PageTemplateModel>(entity);
        }

        #endregion

        #region Plugin

        public static List<PluginModel> ToModels(this List<Entities.Plugin> entity)
        {
            return Mapper.Map<List<Entities.Plugin>, List<PluginModel>>(entity);
        }

        #endregion

        #region User

        public static Entities.User ToEntity(this EditProfileModel model)
        {
            return Mapper.Map<EditProfileModel, Entities.User>(model);
        }

        public static Entities.User ToEntity(this EditProfileModel model, Entities.User entity)
        {
            return Mapper.Map<EditProfileModel, Entities.User>(model, entity);
        }

        public static EditProfileModel ToModel(this Entities.User entity)
        {
            return Mapper.Map<Entities.User, EditProfileModel>(entity);
        }

        public static List<Entities.User> ToEntities(this List<EditProfileModel> models)
        {
            return Mapper.Map<List<EditProfileModel>, List<Entities.User>>(models);
        }

        public static List<EditProfileModel> ToModels(this List<Entities.User> entities)
        {
            return Mapper.Map<List<Entities.User>, List<EditProfileModel>>(entities);
        }

        #endregion

    }
}