#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Reflection;
using System.Web.Mvc;
using System.Configuration;
using Weapsy.Entities;
using Weapsy.Services;
using Recaptcha;

namespace Weapsy.Web.Framework.DataAnnotations
{
    // ==================================================================================
    //  Thanks to Alex Adamyan
    //  http://adamyan.blogspot.com/2010/02/aspnet-mvc-2-localization-complete.html
    // ==================================================================================

	public class LocalizedDisplayNameAttribute : DisplayNameAttribute
	{

        private PropertyInfo _NameProperty;
        private Type _NameResourceType;

        public LocalizedDisplayNameAttribute(string key)
            : base(key)
        {
        }

        public Type NameResourceType
        {
            get
            {
                return _NameResourceType;
            }
            set
            {
                _NameResourceType = value;
                _NameProperty = _NameResourceType.GetProperty(base.DisplayName, BindingFlags.Static | BindingFlags.Public);
            }
        }

        public override string DisplayName
        {
            get
            {
                if (_NameProperty == null)
                {
                    return base.DisplayName;
                }
                return (string)_NameProperty.GetValue(_NameProperty.DeclaringType, null);
            }
        }

	}
}