#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using System.Configuration;
using Weapsy.Entities;
using Weapsy.Services;
using Recaptcha;

namespace Weapsy.Web.Framework.DataAnnotations
{
	public class PosNumNoZeroAttribute : ValidationAttribute
	{
		public override bool IsValid(object value)
		{
			if (value == null) {
				return false;
			}
			int @int = 0;
			if (int.TryParse(value.ToString(), out @int)) {
				if (@int <= 0) {
					return false;
				}
				if (@int > 0) {
					return true;
				}
			}
			return false;
		}
	}
}