#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.Globalization;
using System.IO;
using System.Web.Mvc;

namespace Weapsy.Web.Framework.Engines
{
    public class RazorViewEngine : System.Web.Mvc.RazorViewEngine
    {
        public RazorViewEngine()
        {
            string ThemeName = WeapsyGlobal.Current.Theme.Folder;

            base.MasterLocationFormats = new string[] {
				"~/Themes/" + ThemeName + "/Views/Shared/{0}.cshtml",
				"~/Themes/" + ThemeName + "/Views/{1}/{0}.cshtml",
				"~/Views/Shared/{0}.cshtml",
				"~/Views/{1}/{0}.cshtml"
			};

            base.AreaMasterLocationFormats = new string[] {
				"~/Themes/" + ThemeName + "/Areas/{2}/Views/Shared/{0}.cshtml",
				"~/Themes/" + ThemeName + "/Areas/{2}/Views/{1}/{0}.cshtml",
				"~/Areas/{2}/Views/Shared/{0}.cshtml",
				"~/Areas/{2}/Views/{1}/{0}.cshtml"
			};

            base.ViewLocationFormats = new string[] {
				"~/Themes/" + ThemeName + "/Views/{1}/{0}.cshtml",
				"~/Themes/" + ThemeName + "/Views/Shared/{0}.cshtml",
				"~/Views/{1}/{0}.cshtml",
				"~/Views/Shared/{0}.cshtml",
				"~/Views/Home/Index.cshtml"
			};

            base.AreaViewLocationFormats = new string[] {
				"~/Themes/" + ThemeName + "/Areas/{2}/Views/{1}/{0}.cshtml",
				"~/Themes/" + ThemeName + "/Areas/{2}/Views/Shared/{0}.cshtml",
				"~/Areas/{2}/Views/{1}/{0}.cshtml",
				"~/Areas/{2}/Views/Shared/{0}.cshtml"
			};

            base.PartialViewLocationFormats = base.ViewLocationFormats;
            base.AreaPartialViewLocationFormats = base.AreaViewLocationFormats;
        }
    }
}