#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using System.Web.Mvc;
using Weapsy.Web.Framework.DataAnnotations;

namespace Weapsy.Web.Models.Auth
{
    public class PasswordRecoveryModel
    {
        [Required]
        [DataType(DataType.EmailAddress)]
        [RegularExpression(@"\b[a-zA-Z0-9._%\-+']+@[a-zA-Z0-9.\-]+\.[a-zA-Z]{2,4}\b", ErrorMessageResourceName = "PasswordRecovery_Field_EmailNotValid", ErrorMessageResourceType = typeof(Resources.Auth))]
        [LocalizedDisplayName("PasswordRecovery_Field_Email", NameResourceType = typeof(Resources.Auth))]
        public string Email { get; set; }
        public bool DisplayCaptcha { get; set; }
    }
}