#region Copyright

//  Weapsy - http://www.weapsy.org
//  Copyright (c) 2011-2012 Luca Cammarata Briguglia
//  Licensed under the Weapsy Public License Version 1.0 (WPL-1.0)
//  A copy of this license may be found at http://www.weapsy.org/Documentation/License.txt

#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using System.Web.Mvc;
using Weapsy.Web.Framework.DataAnnotations;

namespace Weapsy.Web.Models.Auth
{
    public class RegisterModel
    {
        [Required]
        [LocalizedDisplayName("Register_Field_UserName", NameResourceType = typeof(Resources.Auth))]
        public string UserName { get; set; }

        [Required]
        [DataType(DataType.EmailAddress)]
        [RegularExpression(@"\b[a-zA-Z0-9._%\-+']+@[a-zA-Z0-9.\-]+\.[a-zA-Z]{2,4}\b", ErrorMessageResourceName = "Register_Field_EmailNotValid", ErrorMessageResourceType = typeof(Resources.Auth))]
        [LocalizedDisplayName("Register_Field_Email", NameResourceType = typeof(Resources.Auth))]
        public string Email { get; set; }

        [Required]
        [StringLength(100, ErrorMessageResourceName = "Register_Field_PasswordLengthErrorMessage", ErrorMessageResourceType = typeof(Resources.Auth), MinimumLength = 6)]
        [DataType(DataType.Password)]
        [LocalizedDisplayName("Register_Field_Password", NameResourceType = typeof(Resources.Auth))]
        public string Password { get; set; }

        [DataType(DataType.Password)]
        [LocalizedDisplayName("Register_Field_ConfirmPassword", NameResourceType = typeof(Resources.Auth))]
        [Compare("Password", ErrorMessageResourceName = "Register_Field_ComparePasswordErrorMessage", ErrorMessageResourceType = typeof(Resources.Auth))]
        public string ConfirmPassword { get; set; }

        public bool DisplayUserName { get; set; }
        public bool DisplayCaptcha { get; set; }
    }
}